using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

namespace WindowsGame1
{
    public class Sound//public static class Sound
    {
        private static AudioEngine engine;
        private static WaveBank wavebank;
        private static SoundBank soundbank;
        static Cue technoMusic;
        static Cue implosion;
        static Cue shot;
        static Cue turn;
        static Cue BGLoop;
        static Cue Happy;

        public static Cue Play(string name)
        {
            Cue returnValue = soundbank.GetCue(name);  //original
            //soundbank.PlayCue("returnValue"); // added
            returnValue.Play(); //original
            return returnValue; //original
        }

        public static void Stop(Cue cue)
        {
            cue.Stop(AudioStopOptions.Immediate);
        }

        /// <summary>
        /// Starts up the sound code
        /// </summary>
        public static void Initialize()
        {
            engine = new AudioEngine("bunnySounds.xgs");
            wavebank = new WaveBank(engine, "Wave Bank.xwb");
            soundbank = new SoundBank(engine, "Sound Bank.xsb");
        }

        public static void Update()  //  Added
        {
            engine.Update();
            
        }

        public static void PlayTechno()
        {
            
            technoMusic = soundbank.GetCue("Techno");
            technoMusic.Play();


        }
        public static void PlayImplosion()
        {

            implosion = soundbank.GetCue("implosion");
            implosion.Play();
        }
        public static void PlayShot()
        {

            shot = soundbank.GetCue("battle029 2");
            shot.Play();
        }
        public static void PlayTurn()
        {
            turn = soundbank.GetCue("CARDSBU");
            turn.Play();
        }

        public static void BG()
        {
            BGLoop = soundbank.GetCue("Loop_95");
            BGLoop.Play();
        }
        public static void BGstop()
        {
            //BGLoop = soundbank.GetCue("Loop_95");
            Stop(BGLoop);
            //BGLoop.Stop(AudioStopOptions.Immediate);
        }
        public static void PlayHappy()
        {
            Happy = soundbank.GetCue("HappySoHappy");
            Happy.Play();
        }
        public static void Happystop()
        {
            //BGLoop = soundbank.GetCue("Loop_95");
            Stop(Happy);
            //BGLoop.Stop(AudioStopOptions.Immediate);
        }

        //public static bool Playing(string cue)
        //{
        //    test = soundbank.GetCue(cue);
        //    return test.IsPlaying;
        //}
        /// <summary>
        /// Shuts down the sound code tidily
        /// </summary>
        public static void Shutdown()
        {
            soundbank.Dispose();
            wavebank.Dispose();
            engine.Dispose();
        }
    }
}