#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using MercuryParticleEngine;
using MercuryParticleEngine.Emitters;
using MercuryParticleEngine.Modifiers;
using System.IO;
using System.Diagnostics;
#endregion

namespace WindowsGame1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        ContentManager content;
        ParticleSystem system;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            content = new ContentManager(Services);

            system = new ParticleSystem(this);
        }

        // initial sprites

        Texture2D grid2, fireControl, mouseimg, dial1Button, dial2Button, lineUp, lineSide, badBunny, goodBunny, strongBunny, fireorder, startup, goOn, goOn1, goBack, arrowPointer, arrowPointerSide, LevelComplete, loopButton, loopButtonLoop, loopButtonStandard, arrowPointUp, mouseimg1, mouseimg2, goOn2, tryAgainButton, gameOverScreen, missImg, reloadButton, resetButton, soundOn, soundOff, soundButton;
        SpriteBatch sprites;
        SpriteFont _font;
        SpriteFont end_font;
        MouseState current_mouse; 
        MouseState old;
        Color bgColor = new Color(157, 187, 97, 255); //157, 187, 97, 255
        Color textColor = new Color(79, 79, 79, 255);
        int resolutionWidth, resolutionHeight;
        bool newLine = false, newLine2 = false, newLine3 = false, newLine4 = false, newLine5 = false, newLine6 = false, newLine7 = false, newLine8 = false, newLine9 = false, newLine10 = false, newLine11 = false, newLine12 = false, newLine13 = false, newLine14 = false, newLine15 = false, newLine16 = false, newLine17 = false, newLine18 = false, newLine19 = false, newLine20 = false, newLine21 = false, newLine22 = false, newLine23 = false, newLine24 = false;
        int lineSpeed = 1;
        int moveLineX;
        int moveLineY;
        int moveFBoxY;
        int right = 1;
        int up = 1;
        bool fireOrdered = false, movePossible = true;
        int lineUpPosX, lineUpPosY, lineSidePosX, lineSidePosY;
        int mouseX, mouseY;
        int array_maxX = 1;   // Number of cols, starting with 0
        int array_maxY = 1;   // Number of rows, starting with 0
        int targetPosX = 0;
        int loopIndex = 0, loopIndexY = 0;
        int increaseNum = 1, increaseNumY = 1;
        int targetPosY;
        Vector2 target, gridPos;
        Vector2 hitDefault;
        Stopwatch time = new Stopwatch();
        Stopwatch time2 = new Stopwatch();
        Stopwatch time3 = new Stopwatch();
        Stopwatch time4 = new Stopwatch();
        Stopwatch time5 = new Stopwatch();
        Stopwatch flashTime = new Stopwatch();
        Emitter explosion;
        int[] enemyXcoord = new int[100];
        int[] enemyYcoord = new int[100];
        int[] bunnyX = new int[100];
        int[] bunnyY = new int[100];
        
        BoundingBox[,] missBox = new BoundingBox[10,5];
        Rectangle[,] missRect = new Rectangle[10,5];
        bool[,] missed = new bool[10,5];
        bool click = false, allIn = false, bunnyError = false, ammoError = false;
        int fireRectPosY;
        string text;
        int numEnemies = 1;
        int enemyDisplay = 1;
        int randomX;
        int fireButton1x, fireButton1y, fireButton2x, fireButton2y, fireButton3x, fireButton3y, fireButton4x, fireButton4y;
        Random X = new Random();
        bool GoOnVisible = true;
        bool GoBackVisible = true;
        int instructionSequence = 0;
        int previousSequence;
        bool instructionArrow = false, instructionArrow2 = false, instructionArrow3 = false, instructionArrow4 = false, instructionArrow5= false;
        Rectangle fireButton1Rect;
        Rectangle fireButton2Rect, fireButton3Rect, fireButton4Rect, dialButton1Rect;
        Rectangle loopButtonRect;
        bool loopFire = false;
        BoundingBox loopButtonBox;
        BoundingBox soundBox;
        int displayNum = 0;
        int displayNumY = 0;
        int loopXmax;
        int loopYmax;
        bool time1 = false;
        int enemies = 0, enemies2 = 0;
        bool firstRun = true;
        int loopAmmo = 1;
        int ammoAvailable = 50;
        int bunny = 0;
        int xx = 0;
        int yy = 0;
        int level;
        int xIncrease, yIncrease, xStart, yStart;
        bool strongHit = false;
        int loopRun = 0;
        bool goOnFlash = false;
        bool errorClick = false;
        bool imovePossible = false;
        int numResets;
        int maxXbunny = 0;
        bool tryAgain = false;
        bool tryAgainBunny = false;
        int stage0enemies, stage1enemies, stage2enemies;
        int enemiesCured;
        int totalEenemies;
        int points;
        int totalPoints;
        int randomCured;
        int minXbunny = 10;
        int bunnyHint;
        string text2;
        string text3;
        bool resetRun = false;
        int stage0Start, stage0increase;
        int stage1Start, stage1increase;
        int stage2Start, stage2increase;
        bool instrucInc = true;
        Color xColor;
        Color yColor;
        bool cueHandle = false;
        bool cueHandleLoop = false;
        bool soundClick;
        bool happyPlay = false;
        bool initialWrite = false;
        TextWriter tw = new StreamWriter("Logging.txt");
        int sets = 3;


        //Logging Clocks and vars
        Stopwatch overallTime = new Stopwatch();
        Stopwatch levelTime = new Stopwatch();
        Stopwatch activityTime = new Stopwatch();
        string activity;
        bool correct;
        int enemyCount = 5;
        int logXstart = 0;
        int logXincrease = 0;
        int logXstart2 = 0;
        int logXincrease2 = 0;

        int logYstart = 0;
        int logYincrease = 0;
        int logYstart2 = 0;
        int logYincrease2 = 0;
        int shots = 0;
        

        //************************************************
        int array_sizeX = 10;//  where you want bunnies to line up with, ex: 10 would fit bunnies evenly with a grid 10 * y)
        //************************************************

        BoundingBox mouseBox;
        BoundingBox resetBox;
        BoundingBox fireSector, fireOrderBox, GoOnBox, GoBackBox;
        Bunny[] bunnyArray = new Bunny[100];  
        KeyboardState keyboardState;
        int[] bunnyHit = new int[100];
        //void levelLoad()
        //{
        //    TextReader tr = new StreamReader(@"level.txt");
        //    String[] testlevel = tr.ReadToEnd().Split('!');
        //    foreach (String x in testlevel)
        //    {
        //        String[] testlevel2 = x.Split(',');
        //        if (testlevel2[0] == "0")
        //            bunnyArray[0] = null;
        //        if (testlevel2[0] == "1")
        //            bunnyArray[0].type = "good";
        //        if (testlevel2[0] == "2")
        //            bunnyArray[0].type = "bad";
               
        //    }
        //}
        protected override void Initialize()
        {

            ////////////Level Load



            // Load initial sprites
            fireControl = content.Load<Texture2D>("fireControlNew");
            grid2 = content.Load<Texture2D>("grid2");
            mouseimg = content.Load<Texture2D>("mouseimg");
            mouseimg1 = content.Load<Texture2D>("mouseimg");
            dial1Button = content.Load<Texture2D>("dialButton");
            lineUp = content.Load<Texture2D>("lineUp");
            lineSide = content.Load<Texture2D>("lineSide");
            dial2Button = dial1Button;
            goodBunny = content.Load<Texture2D>("bunny0");
            badBunny = content.Load<Texture2D>("bunny1");
            _font = content.Load<SpriteFont>("SpriteFont1");
            end_font = content.Load<SpriteFont>("SpriteFont2");
            fireorder = content.Load<Texture2D>("fireorder");
            startup = content.Load<Texture2D>("StartScreenJPG");
            goOn = content.Load<Texture2D>("GoOnButton");
            goOn1 = content.Load<Texture2D>("GoOnButton");
            goOn2 = content.Load<Texture2D>("GoOnButtonFlash");
            goBack = content.Load<Texture2D>("GoBackButton");
            arrowPointer = content.Load<Texture2D>("arrowPoint");
            LevelComplete = content.Load<Texture2D>("LevelComplete");
            loopButtonLoop = content.Load<Texture2D>("newLoopButton");
            loopButtonStandard = content.Load<Texture2D>("newLoopButtonStandard");
            strongBunny = content.Load<Texture2D>("bunny2");
            arrowPointUp = content.Load<Texture2D>("arrowPointUp");
            arrowPointerSide = content.Load<Texture2D>("arrowPointSide");
            tryAgainButton = content.Load<Texture2D>("tryAgainButton");
            gameOverScreen = content.Load<Texture2D>("GameOverScreen");
            missImg = content.Load<Texture2D>("missImg");
            reloadButton = content.Load<Texture2D>("reload");
            resetButton = content.Load<Texture2D>("resetButton");
            mouseimg2 = content.Load<Texture2D>("mouseimg2");
            soundOn = content.Load<Texture2D>("soundpic");
            soundOff = content.Load<Texture2D>("soundpicNo");
            soundButton = soundOn;

            text = " ";
            text2 = " ";
            text3 = " ";
            activity = "";

            //soundPlay = Sound.Playing("implosion");

            //////////////////////Set the Start Level; 0 is start screen ////////////////
            level = 0;
            //*****************************************************************

            xColor = Color.Navy;
            yColor = Color.MediumVioletRed;

            loopXmax = array_maxX;
            loopYmax = array_maxY;

            sprites = new SpriteBatch(graphics.GraphicsDevice);

            explosion = new CircleEmitter(150, 0f, false, CircleEmitter.RadialSpread.FromCenter);
            explosion.DischargeQuantity = 2;         
            explosion.ParticleLifespan = 1000;       
            explosion.ParticleSpeed = 30;            
            explosion.ParticleSpeedRange = 50;       

            
            
            explosion.ApplyModifier(new TimedTriggerController(200f));
            explosion.ApplyModifier(new Opacity3Modifier(1f, .5f, 0f, 0f, 128));
            explosion.ApplyModifier(new Color3Modifier(Color.Green.ToVector3(), Color.Brown.ToVector3(), 0.75f, Color.Red.ToVector3(), 128));        
            explosion.ApplyModifier(new Scale2Modifier(.9f, 1.5f));
            explosion.ApplyModifier(new ParticleRotationModifier(.05f));
            explosion.Position = new Vector2(2000, 2000);

            ImageStrip xtra = new ImageStrip("xtra");
            xtra.Asset = @"Resources\xtra1";
            xtra.FrameHeight = 128;
            xtra.Frames = 4;
            xtra.FrameWidth = 128;

            system.ImageStrips.Add("xtra", xtra);

            explosion.ImageStrip = "xtra";
            explosion.Frame = 3;
            system.AddEmitter(explosion);
            randomX = X.Next(10);
            enemyDisplay = 1;
            numEnemies = 1;

            stage0Start = 9;
            stage0increase = 9;
            stage1Start = 8;
            stage1increase = 8;
            stage2Start = 7;
            stage2increase = 7;

            randomCured = X.Next(5);
            soundClick = false;

            bunnyDeclare();

            //Logging
            overallTime.Start();

            base.Initialize();
            Sound.Initialize();
            if (cueHandle == false)
            {
                Sound.PlayTechno();
                Sound.BG();
                cueHandle = true;
            }


        }

        protected override void LoadGraphicsContent(bool loadAllContent)
        {
            if (loadAllContent)
            {

            }

        }

        protected override void UnloadGraphicsContent(bool unloadAllContent)
        {
            if (unloadAllContent)
            {
                content.Unload();
            }
        }
        bool slowInput = false;
        protected override void Update(GameTime gameTime)
        {   
            //record the old keyboard state then get the current one.
            keyboardState = Keyboard.GetState();

            //Mike: added this to skip levels
            if (keyboardState.IsKeyUp(Keys.F1))
            {
                slowInput = true;
            }
            if (keyboardState.IsKeyDown(Keys.F1) && slowInput == true)
            {
                level++;
                reset();
                if (level > 5)
                    endGame();
                slowInput = false;
            }
            
          current_mouse = Mouse.GetState();
          // The mouse x and y positions are returned relative to the
          // upper-left corner of the game window.
          mouseX = current_mouse.X;
          mouseY = current_mouse.Y;


           base.Update(gameTime);
           Sound.Update();
        } 
        
        protected override void Draw(GameTime gameTime)
        {

            
            explosion.Position = new Vector2(2000, 2000);
            graphics.GraphicsDevice.Clear(bgColor);
            resolutionWidth = graphics.GraphicsDevice.Viewport.Width;
            resolutionHeight = graphics.GraphicsDevice.Viewport.Height;
            sprites.Begin();
            mouseBox = new BoundingBox(
                new Vector3(
                (mouseX - 1), (mouseY - 1), (0)),
                new Vector3(
                (mouseX + 1), (mouseY + 1), (0))
                  );
            
            drawGrid();
            drawBunnies();
            fireOrders(gameTime);
            controls();
            
            lineMovement(gameTime);
            if (loopFire == false)
            {
                firePositioning();
            }

            else if (loopFire == true)
            {
                loopFireTrue();

            }
            instructionarrows();


            BGsound();
            
            runLevelSettings();



            mouse();


            //sprites.DrawString(_font, Convert.ToString(logXstart), Vector2.Zero, Color.White);
            //sprites.DrawString(_font, Convert.ToString(logXincrease), new Vector2(0, 50), Color.White);
            //sprites.DrawString(_font, Convert.ToString(logYstart), new Vector2(20, 0), Color.White);
            //sprites.DrawString(_font, Convert.ToString(logYincrease), new Vector2(20, 50), Color.White);

            //sprites.DrawString(_font, Convert.ToString(logXstart2), new Vector2(100, 0), Color.Red);
            //sprites.DrawString(_font, Convert.ToString(logXincrease2), new Vector2(100, 50), Color.Red);
            //sprites.DrawString(_font, Convert.ToString(logYstart2), new Vector2(120, 0), Color.Red);
            //sprites.DrawString(_font, Convert.ToString(logYincrease2), new Vector2(120, 50), Color.Red);
            sprites.End();
            
            base.Draw(gameTime);
        }

        private void BGsound()
        {
            Rectangle soundRect = new Rectangle(220, 515, 40, 40);
            soundBox = new BoundingBox(
                new Vector3(220, 515, 0),
                new Vector3(260, 555, 0)
                );
            sprites.Draw(soundButton, soundRect, Color.White);
            if (mouseBox.Intersects(soundBox) && current_mouse.LeftButton == ButtonState.Pressed)
            {
                soundClick = true;
            }
            else if (soundClick == true && current_mouse.LeftButton == ButtonState.Released)
            {
                if (soundButton == soundOn)
                {
                    Sound.BGstop();
                    soundButton = soundOff;
                    Sound.Play("QUICKCL");
                }
                else if (soundButton == soundOff)
                {
                    Sound.BG();
                    Sound.Play("QUICKCL");
                    soundButton = soundOn;
                }
                soundClick = false;
            }
        }

        private void loopFireTrue()
        {
            Sound.Update();
            loopButtonRect = new Rectangle(395, 430, 110, 35);

            loopButtonBox = new BoundingBox(
             new Vector3((395), (430), (0)),
             new Vector3((505), (465), (0))
                );

            loopButton = loopButtonLoop;
            BoundingBox mouseBox = new BoundingBox(
    new Vector3(
        (mouseX - 1), (mouseY - 1), (0)),
    new Vector3(
        (mouseX + 1), (mouseY + 1), (0))
        );
            //int XmaxButton = 0;
            //int YmaxButton = 0;
            //Rectangle YmaxRect;
            //Rectangle XmaxRect;
            ////////////////////////////////////////Original Settings//////////////////
            //if (level == 2)
            //{
            //    fireButton1x = (resolutionWidth - 325);
            //    fireButton1y = ((resolutionHeight - (resolutionHeight / 3) + 40) + fireControl.Height / 3);
            //    fireButton2x = fireButton1x + 200;
            //    fireButton2y = fireButton1y;
            //    fireButton3x = fireButton1x + 20;
            //    fireButton3y = fireButton1y + 33;
            //    fireButton4x = fireButton3x + 180;
            //    fireButton4y = fireButton3y;
            //    XmaxButton = fireButton1x + 100;
            //    YmaxButton = fireButton3x + 90;
            //    fireButton1Rect = new Rectangle(fireButton1x, fireButton1y, 20, 30);
            //    fireButton2Rect = new Rectangle(fireButton2x, fireButton2y, 20, 30);
            //    fireButton3Rect = new Rectangle(fireButton3x, fireButton3y, 20, 30);
            //    fireButton4Rect = new Rectangle(fireButton4x, fireButton4y, 20, 30);
            //    XmaxRect = new Rectangle(XmaxButton, fireButton1y, 20, 30);
            //    YmaxRect = new Rectangle(YmaxButton, fireButton3y, 20, 30);
            //    sprites.Draw(dial1Button, fireButton1Rect, Color.White);
            //    sprites.Draw(dial1Button, XmaxRect, Color.White);
            //}

                //////////////////New Settings//////////////////////
                fireButton1x = fireButton3x + 20;
                fireButton1y = fireButton3y + 33;
                fireButton2x = fireButton1x + 180;
                fireButton2y = fireButton1y;
                fireButton3x = (resolutionWidth - 325);
                fireButton3y = ((resolutionHeight - (resolutionHeight / 3) + 40) + fireControl.Height / 3);
                fireButton4x = fireButton3x + 200;
                fireButton4y = fireButton3y;
                int XmaxButton = fireButton1x + 90;
                int YmaxButton = fireButton3x + 100;
                fireButton1Rect = new Rectangle(fireButton1x, fireButton1y, 20, 30);
                fireButton2Rect = new Rectangle(fireButton2x, fireButton2y, 20, 30);
                fireButton3Rect = new Rectangle(fireButton3x, fireButton3y, 20, 30);
                fireButton4Rect = new Rectangle(fireButton4x, fireButton4y, 20, 30);
                Rectangle XmaxRect = new Rectangle(XmaxButton, fireButton1y, 20, 30);
                Rectangle YmaxRect = new Rectangle(YmaxButton, fireButton3y, 20, 30);
                sprites.Draw(dial1Button, fireButton1Rect, Color.White);
                sprites.Draw(dial1Button, XmaxRect, Color.White);


            //Fire and Reset Bounding Boxes
            BoundingBox fireBox = new BoundingBox(
                new Vector3(
                    (272),
                    (449),
                    (0)),
                new Vector3(
                    (347),
                    (470),
                    (0))
                        );

            resetBox = new BoundingBox(
                new Vector3(
                    (272),
                    (484),
                    (0)),
                new Vector3(
                    (347),
                    (506),
                    (0))
                      );



            // X left and right BBoxes
            BoundingBox fireButtonUp1 = new BoundingBox(
                 new Vector3(
                     (fireButton1x),
                     (fireButton1y),
                     (0)),
                 new Vector3(
                     (fireButton1x + 20),
                     (fireButton1y + 14),
                     (0)
                     )
                     );

            BoundingBox fireButtonDown1 = new BoundingBox(
                 new Vector3(
                     (fireButton1x),
                     (fireButton1y + 15),
                     (0)),
                  new Vector3(
                     (fireButton1x + 20),
                     (fireButton1y + 30),
                     (0)
                     )
                     );
            // Y up and down BBoxes

                
                sprites.Draw(dial2Button, fireButton2Rect, Color.White);

                BoundingBox fireButtonUp2 = new BoundingBox(
                   new Vector3(
                       (fireButton2x),
                       (fireButton2y),
                       (0)),
                   new Vector3(
                       (fireButton2x + 20),
                       (fireButton2y + 14),
                       (0)
                       )
                       );
                BoundingBox fireButtonDown2 = new BoundingBox(
                    new Vector3(
                        (fireButton2x),
                        (fireButton2y + 15),
                        (0)),
                     new Vector3(
                        (fireButton2x + 20),
                        (fireButton2y + 30),
                        (0)
                        )
                        );

            ////////////////////X and Y max Bounding Boxes
                BoundingBox XmaxUpBox = new BoundingBox(
                    new Vector3(
                    (XmaxButton),
                    (fireButton1y),
                    (0)),
                    new Vector3(
                    (XmaxButton + 20),
                    (fireButton1y + 14),
                    (0)
                    )
                    );
                BoundingBox XmaxDownBox = new BoundingBox(
                    new Vector3(
                        (XmaxButton),
                        (fireButton1y + 15),
                        (0)),
                     new Vector3(
                        (XmaxButton + 20),
                        (fireButton1y + 30),
                        (0)
                        )
                        );

            //////////////////////////Y and X max loop Button Function
                
            // X maximum for loop Button
            if ((mouseBox.Intersects(XmaxUpBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine20 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine20 == true)
                    {
                        if (movePossible == true)
                        {
                            loopXmax++;
                        }
                        if (loopXmax <= array_maxX && loopXmax > 0)
                            Sound.PlayTurn();

                        if (loopXmax > array_maxX)
                        {
                            Sound.Play("TICK");
                            loopXmax--;
                        }


                        newLine20 = false;

                    }
                }

                if ((mouseBox.Intersects(XmaxDownBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine21 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine21 == true)
                    {
                        if (movePossible == true)
                        {
                            loopXmax--;

                        }
                        if (loopXmax < 0)
                        {
                            loopXmax = 0;
                            Sound.Play("TICK");
                        }

                        if (loopXmax <= array_maxX && loopXmax > loopIndex)
                        {
                            Sound.PlayTurn();
                        }
                        
                        if (loopXmax <= loopIndex)
                        {
                            Sound.Play("TICK");
                            loopXmax++;
                        }
                        if (increaseNum > loopXmax)
                        {
                            Sound.Play("TICK");
                            increaseNum -= 1;
                        }
                        
                        newLine21 = false;
                    }

                }

            // Y max for loop

                if (level > 2)
                {
                    sprites.Draw(dial1Button, YmaxRect, Color.White);
                    BoundingBox fireButtonUp3 = new BoundingBox(
                        new Vector3(
                            (fireButton3x),
                            (fireButton3y),
                            (0)),
                        new Vector3(
                            (fireButton3x + 20),
                            (fireButton3y + 14),
                            (0)
                            )
                            );
                    BoundingBox fireButtonDown3 = new BoundingBox(
                        new Vector3(
                            (fireButton3x),
                            (fireButton3y + 15),
                            (0)),
                         new Vector3(
                            (fireButton3x + 20),
                            (fireButton3y + 30),
                            (0)
                            )
                            );
                    ////////////////////////////////////////////////////////  Button 4 Bounding Box
                    BoundingBox fireButtonUp4 = new BoundingBox(
                       new Vector3(
                           (fireButton4x),
                           (fireButton4y),
                           (0)),
                       new Vector3(
                           (fireButton4x + 20),
                           (fireButton4y + 14),
                           (0)
                           )
                           );
                    BoundingBox fireButtonDown4 = new BoundingBox(
                        new Vector3(
                            (fireButton4x),
                            (fireButton4y + 15),
                            (0)),
                         new Vector3(
                            (fireButton4x + 20),
                            (fireButton4y + 30),
                            (0)
                            )
                            );
                    // Draw Buttons

                    sprites.Draw(dial2Button, fireButton3Rect, Color.White);
                    sprites.Draw(dial2Button, fireButton4Rect, Color.White);
                    BoundingBox YmaxUpBox = new BoundingBox(
                        new Vector3(
                        (YmaxButton),
                        (fireButton3y),
                        (0)),
                        new Vector3(
                        (YmaxButton + 20),
                        (fireButton3y + 14),
                        (0)
                        )
                        );
                    BoundingBox YmaxDownBox = new BoundingBox(
                        new Vector3(
                            (YmaxButton),
                            (fireButton3y + 15),
                            (0)),
                         new Vector3(
                            (YmaxButton + 20),
                            (fireButton3y + 30),
                            (0)
                            )
                            );

                    if ((mouseBox.Intersects(YmaxUpBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine22 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine22 == true)
                        {
                            if (movePossible == true)
                            {
                                loopYmax++;
                            }
                            if (loopYmax <= array_maxY && loopYmax > 0)
                                Sound.PlayTurn();

                            if (loopYmax > array_maxY)
                            {
                                Sound.Play("TICK");
                                loopYmax--;
                            }



                            newLine22 = false;

                        }
                    }

                    if ((mouseBox.Intersects(YmaxDownBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine23 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine23 == true)
                        {
                            if (movePossible == true)
                            {
                                loopYmax--;

                            }
                            if (loopYmax < 0)
                            {
                                loopYmax = 0;
                                Sound.Play("TICK");
                            }

                            if (loopYmax <= array_maxY && loopYmax > loopIndexY)
                            {
                                Sound.PlayTurn();
                            }
                            if (loopYmax <= loopIndexY)
                            {
                                Sound.Play("TICK");
                                loopYmax++;
                            }
                            if (increaseNumY > loopYmax)
                            {
                                Sound.Play("TICK");
                                increaseNumY -= 1;
                            }
                            newLine23 = false;
                        }

                    }

                    ////////////////////////////////////////////////// Button 3 function Yindex inc and dec
                    if ((mouseBox.Intersects(fireButtonUp3)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine16 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine16 == true)
                        {
                            if (movePossible == true)
                            {
                                loopIndexY++;
                                displayNumY++;
                            }
                            if (loopIndexY < array_maxY && loopIndexY >= 0)
                            {
                                Sound.PlayTurn();
                            }
                            if (loopIndexY > loopYmax)
                            {
                                loopYmax++;
                            }
                            if (loopIndexY >= array_maxY)
                            {
                                Sound.Play("TICK");
                                loopIndexY--;
                                displayNumY--;
                            }


                            newLine16 = false;

                        }
                    }

                    if ((mouseBox.Intersects(fireButtonDown3)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine17 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine17 == true)
                        {
                            if (movePossible == true)
                            {
                                loopIndexY--;
                                displayNumY--;
                            }
                            if (loopIndexY <= 0)
                            {
                                loopIndexY = 0;
                                displayNumY = 0;
                                Sound.Play("TICK");
                               
                            }

                            if (loopIndexY < loopYmax && loopIndexY > 0)
                            {
                                Sound.PlayTurn();
                            }
                                newLine17 = false;
                        }

                    }
                    //////////////////////////////////////Button 4 function

                    if ((mouseBox.Intersects(fireButtonUp4)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine18 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine18 == true)
                        {
                            if (movePossible == true)
                                increaseNumY++;
                            if (increaseNumY < loopYmax && increaseNumY > 0 && increaseNumY < loopYmax)
                                Sound.PlayTurn();

                            if (increaseNumY >= loopYmax)
                            {
                                Sound.Play("TICK");
                                increaseNumY -= 1;
                            }
                            newLine18 = false;

                        }
                    }

                    if ((mouseBox.Intersects(fireButtonDown4)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                    {
                        newLine19 = true;
                        current_mouse = Mouse.GetState();
                    }
                    else if ((current_mouse.LeftButton == ButtonState.Released))
                    {
                        if (newLine19 == true)
                        {
                            if (movePossible == true)
                                increaseNumY--;
                            if (increaseNumY <= 1)
                            {
                                increaseNumY = 1;
                                Sound.Play("TICK");
                            }
                            if (increaseNumY < loopYmax && increaseNumY > 0 && increaseNumY > 1)
                                Sound.PlayTurn();


                            newLine19 = false;
                        }

                    }

                }

            //////////////////////////////////////////////////////////



            ////////////////////////////////////////////////////////////

                if ((mouseBox.Intersects(fireButtonUp2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine7 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine7 == true)
                    {
                        if (movePossible == true)
                            increaseNum++;
                        if (increaseNum < loopXmax && increaseNum > 0)
                            Sound.PlayTurn();

                        if (increaseNum >= loopXmax)
                        {
                            Sound.Play("TICK");
                            increaseNum--;
                        }
                        newLine7 = false;

                    }
                }

                if ((mouseBox.Intersects(fireButtonDown2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine8 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine8 == true)
                    {
                        if (movePossible == true)
                            increaseNum--;
                        if (increaseNum <= 1)
                        {
                            increaseNum = 1;
                            Sound.Play("TICK");
                        }
                        if (increaseNum < loopXmax && increaseNum > 1)
                            Sound.PlayTurn();

                        newLine8 = false;
                    }

                }

                if ((mouseBox.Intersects(fireButtonUp1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine5 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine5 == true)
                {
                    if (movePossible == true)
                    {
                        loopIndex++;
                        displayNum++;
                    }
                    if (loopIndex < array_maxX && loopIndex > 0)
                        Sound.PlayTurn();

                    if (loopIndex > loopXmax)
                    {
                        loopXmax++;

                    }
                    if (loopIndex >= array_maxX)
                    {
                        Sound.Play("TICK");
                        loopIndex--;
                        displayNum--;
                    }

                    newLine5 = false;

                }
            }

            if ((mouseBox.Intersects(fireButtonDown1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine6 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine6 == true)
                {
                    if (movePossible == true)
                    {
                        loopIndex--;
                        displayNum--;
                    }
                    if (loopIndex <= 0)
                    {
                        loopIndex = 0;
                        displayNum = 0;
                        Sound.Play("TICK");
                    }

                    if (loopIndex <= loopXmax && loopIndex > 0)
                        Sound.PlayTurn();
                    newLine6 = false;
                }

            }
  ////////////////////////////When Fire Button is Pressed in Loop Mode          
            if ((mouseBox.Intersects(fireBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine9 = true;
                time1 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine9 == true)
                {
                        if (allIn == true && ammoAvailable> 0 && loopAmmo > 0)
                            {
                                //Sound.Play("implosion");
                                
                                xx = loopIndex;
                                yy = loopIndexY;
                                time1 = true;
                                fireOrdered = true;

                                movePossible = false;
                                //Logging();
                                newLine9 = false;
                            }
                

                if (allIn == false)
                   {
                        bunnyError = true;
                   }
                if (ammoAvailable <= 0 || loopAmmo == 0)
                   {
                       ammoError = true;
                   }
                }
                newLine9 = false;
            }

            // Resets Target position to real time when not firing
            if (time1 == true)
            {
                targetPosX = loopIndex;
                targetPosY = loopIndexY;
                xx = loopIndex;
                yy = loopIndexY;
                

            }

            //looping code
            if (fireOrdered == true)
            {
                time.Start();
                
                // Starts the next row
                if (xx >= loopXmax)
                {
                    //strongHit = true;
                    xx = loopIndex;
                    yy += increaseNumY;
                    
                }


            
                // Resets the loop after completed
                    if ((yy >= loopYmax))
                    {
                        fireOrdered = false;
                        time1 = true;
                        movePossible = true;
                        xx = loopIndex;
                        yy = loopIndexY;
                        targetPosX = 0;
                        targetPosY = 0;
                        displayNum = loopIndex;
                        displayNumY = loopIndexY;
                        loopAmmo--;
                    }
                
                    // Runs through loop

                        if (time.Elapsed.Milliseconds < 200)
                        {
                            strongHit = true;
                            targetPosX = xx;
                            targetPosY = yy;
                            explosion.Position.X = target.X + 15;
                            explosion.Position.Y = target.Y + 15;
                            if (ammoAvailable < 1)
                            {
                                fireOrdered = false;
                                time1 = true;
                                movePossible = true;
                                xx = loopIndex;
                                yy = loopIndexY;
                                targetPosX = 0;
                                targetPosY = 0;
                                displayNum = loopIndex;
                                displayNumY = loopIndexY;
                            }
                            
                        }
                        if (time.Elapsed.Milliseconds >= 200)
                        { 

                            strongHit = false;
                            //Sound.Play("battle029 2");
                            Sound.PlayShot();
                            movePossible = false;
                            xx += increaseNum;
                            

                            //Catches for Y = 0 just repeating the loop && when X&Y increase nums = 0;
                            if (increaseNumY == 0 && xx >= loopXmax || (increaseNum == 0 && increaseNumY == 0))
                            {
                                strongHit = false;
                                fireOrdered = false;
                                time1 = true;
                                xx = loopIndex;
                                yy = loopIndexY;
                                targetPosX = array_maxX;//0;
                                targetPosY = array_maxY;//0;
                                displayNum = loopIndex;
                                displayNumY = loopIndexY;
                                movePossible = true;
                                loopAmmo--;
                            }

                            // Catches X increase num = 0
                            if (increaseNum == 0)
                            {
                                strongHit = false;
                                yy += increaseNumY;
                            }
                                          
                            newLine10 = false;
                            time1 = false;
                            ammoAvailable--;

                            time.Stop();
                            time.Reset();


                        }

                //Logging Code      //Not for gameplay!
                        if (fireOrdered == false)
                        {
                            shots++;
                            if (enemyDisplay == 0)
                            {
                                correct = true;
                                sets--;
                                
                                //initialWrite = false;
                            }
                            else if (enemyDisplay != 0)
                            {
                                correct = false;
                            }
                            Logging();
                        }
                // End Log code

            }
            if (ammoAvailable <= 0 || loopAmmo <= 0)
            {
                ammoError = true;
            }

            

            if ((mouseBox.Intersects(resetBox)) && (current_mouse.LeftButton == ButtonState.Pressed))
            {
                newLine10 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine10 == true)
                {
                    if (resetRun == true)
                    {
                        Sound.Play("QUICKCL");
                        resetRun = false;
                        newLine10 = false;
                        time3.Reset();
                    }
                    else if (resetRun == false)
                    {
                        Sound.Play("QUICKCL");
                        resetRun = true;
                        newLine10 = false;
                    }
                }

            }

            //Fixes Error in Collision now being recoginzed entering Level 5
            if (newLine15 == true)
            {
                //Sound.Play("QUICKCL");
                ammoAvailable = numEnemies;
                for (int x = 0; x < bunnyHit.Length; x++)
                {
                    bunnyHit[x] = 0;
                }

                for (int i = 0; i < numEnemies; i++)
                {
                    for (int z = 0; z < i; z++)
                    {
                        if ((bunnyY[i] == bunnyY[z]) && (bunnyX[i] == bunnyX[z]))
                        {
                            bunnyHit[z] = 1;
                            bunnyHit[i] = 2;
                        }
                    }
                }
                loopAmmo = 2;

                time3.Reset();
                imovePossible = true;
                ammoError = false;
                tryAgain = false;

                for (int x = 0; x < array_maxX; x++)
                {
                    for (int y = 0; y < array_maxY; y++)
                    {
                        missed[x, y] = false;
                    }
                }
                newLine15 = false;
            }
            ///////////////////////////////////////////////////////////////

            sprites.DrawString(_font, "for (c =      ; c <" + loopXmax,
                    new Vector2(
                    (fireButton1x - 100), fireButton2y + 5), Color.Navy);
            sprites.DrawString(_font, "for (c =      ; c <",
                    new Vector2(
                    (fireButton1x - 100), fireButton2y + 5), Color.Red);
            
            sprites.DrawString(_font, "                        ; c+=     )",
        new Vector2(
        (fireButton1x - 100), fireButton2y + 5), Color.Red);



            sprites.DrawString(_font, Convert.ToString(displayNum),
                    new Vector2(
                    (fireButton1x - 15), fireButton1y + 5), Color.Navy);

              sprites.DrawString(_font, Convert.ToString(increaseNum),
                        new Vector2(
                        (fireButton2x - 15), fireButton2y + 5), Color.Navy);
              if (level > 2)
              {
                  sprites.DrawString(_font, "for (r =      ; r < " + loopYmax,
new Vector2(
(fireButton3x - 100), fireButton3y + 5), Color.MediumVioletRed);  

                  sprites.DrawString(_font, "for (r =      ; r <       ; r+=      )",
              new Vector2(
              (fireButton3x - 100), fireButton3y + 5), Color.Red);
  

                  sprites.DrawString(_font, Convert.ToString(displayNumY),
                          new Vector2(
                          (fireButton3x - 15), fireButton3y + 5), Color.MediumVioletRed);

                  sprites.DrawString(_font, Convert.ToString(increaseNumY),
                            new Vector2(
                            (fireButton4x - 15), fireButton4y + 5), Color.MediumVioletRed);
              }
            target.X = hitDefault.X + (75 * targetPosX);
            target.Y = hitDefault.Y + (75 * targetPosY);

            fireSector = new BoundingBox(
                new Vector3((target.X), (target.Y), (0)),
                new Vector3((target.X + 15), (target.Y + 15), (0))
                );


            //********************************End Fire Code****************************

            sprites.Draw(loopButton, loopButtonRect, Color.White);
        }

        private void mouse()
        {
            Vector2 mousePos = new Vector2(
            (mouseX - 15), (mouseY - 15));
            sprites.Draw(mouseimg, mousePos, Color.White);
        }

        private void fireOrders(GameTime gameTime)
        {
            Sound.Update();
            fireOrderBox = new BoundingBox(
                  new Vector3((568), (414), (0)),
                  new Vector3((665), (449), (0))
               );

            float moveFactorPerSecond = 150 *
        (float)gameTime.ElapsedRealTime.Milliseconds / 1000.0f;
            float lineUpChange = lineSpeed * moveFactorPerSecond;


            fireRectPosY = 410 + moveFBoxY;
            int FBOXmax = 120;//135;
            int FBOXmin = 413;


            if ((mouseBox.Intersects(fireOrderBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && (click == true))
            {
                newLine11 = true;
                old = current_mouse;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released) && (click == true))
            {

                if (newLine11 == true)
                {
                    click = false;
                }
                newLine11 = false;
            }

            if ((mouseBox.Intersects(fireOrderBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && (click == false))
            {
                newLine12 = true;
                old = current_mouse;
                current_mouse = Mouse.GetState();
            }

            else if ((current_mouse.LeftButton == ButtonState.Released) && click == false)
            {

                if (newLine12 == true)
                {
                    click = true;

                }
                newLine12 = false;
            }
            if (click == true)
            {
                if ((fireRectPosY > FBOXmax))
                {
                    moveFBoxY -= (lineSpeed + 5);
                }
            }

            if (click == false)
            {
                if ((fireRectPosY < FBOXmin))
                {
                    moveFBoxY += (lineSpeed + 5);
                }
            }

            if ((mouseBox.Intersects(GoOnBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && (click == true))
            {
                newLine13 = true;
                old = current_mouse;
                current_mouse = Mouse.GetState();
            }

            else if ((current_mouse.LeftButton == ButtonState.Released) && click == true)
            {

                if (newLine13 == true)
                {
                    Sound.Play("QUICKCL");
                    instructionSequence++;
                    previousSequence++;

                }
                newLine13 = false;
            }
            if ((mouseBox.Intersects(GoBackBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && (click == true))
            {
                newLine14 = true;
                old = current_mouse;
                current_mouse = Mouse.GetState();
            }

            else if ((current_mouse.LeftButton == ButtonState.Released) && click == true)
            {

                if (newLine14 == true)
                {
                    Sound.Play("QUICKCL");
                    instructionSequence--;
                    previousSequence--;
                    if (instructionSequence <= 0)
                    {
                        instructionSequence = 1;
                        previousSequence = 1;
                    }
                }
                newLine14 = false;
            }         

            Rectangle fireOrderRect = new Rectangle(382, fireRectPosY, 300, 293);
            sprites.Draw(fireorder, fireOrderRect, Color.White);
            if (GoOnVisible == true)
            {
                GoOnBox = new BoundingBox(
                    new Vector3((fireOrderRect.Right - goOn.Width), (fireOrderRect.Bottom - goOn.Height), (0)),
                    new Vector3((fireOrderRect.Right), (fireOrderRect.Bottom), (0))
                );
                sprites.Draw(goOn, new Vector2((fireOrderRect.Right - goOn.Width), (fireOrderRect.Bottom - goOn.Height)), Color.White);
                if (goOnFlash == true)
                {
                    time4.Start();
                    if (time4.Elapsed.Milliseconds < 750)
                    {
                        goOn = goOn1;
                    }
                    if (time4.Elapsed.Milliseconds > 750)
                    {
                        goOn = goOn2;
                        
                    }
                    if (time4.Elapsed.Milliseconds > 1500)
                    {
                        time4.Stop();
                        time4.Reset();
                    }
                }

            }
            if (GoBackVisible == true)
            {
                GoBackBox = new BoundingBox(
                    new Vector3((fireOrderRect.Left), (fireOrderRect.Bottom - goBack.Height), (0)),
                    new Vector3((fireOrderRect.Left + goBack.Width), (fireOrderRect.Bottom), (0))
                );
                sprites.Draw(goBack, new Vector2((fireOrderRect.Left), (fireOrderRect.Bottom - goOn.Height)), Color.White);
            }

            if (GoOnVisible == false)
            {
                GoOnBox = new BoundingBox(
                    new Vector3((-100),(-100),(0)),
                    new Vector3((-100),(-100),(0))
                );
            }
            if (GoBackVisible == false)
            {
                GoBackBox = new BoundingBox(
                    new Vector3((-100), (-100), (0)),
                    new Vector3((-100), (-100), (0))
                );
            }
            if (resetRun == true)
            {
                tryAgain = false;
                instructionArrow = false;
                instructionArrow2 = false;
                instructionArrow3 = false;
                instructionArrow4 = false;
                instructionArrow5 = false;
                //fireOrdered = false;
                text3 = " ";
                text2 = " ";
                Rectangle tryAgainRect = new Rectangle(475, fireRectPosY + 255, 100, 35);
                sprites.Draw(reloadButton, tryAgainRect, Color.White);
                BoundingBox tryAgainBox2 = new BoundingBox(
                    new Vector3(464, fireRectPosY + 255, 0),
                    new Vector3(564, fireRectPosY + 290, 0));

                Rectangle ResetRect = new Rectangle(475, fireRectPosY + 140, 100, 35);
                sprites.Draw(resetButton, ResetRect, Color.White);
                BoundingBox resetBox2 = new BoundingBox(
                    new Vector3(464, fireRectPosY + 140, 0),
                    new Vector3(564, fireRectPosY + 175, 0));
                imovePossible = false;
                if (mouseBox.Intersects(resetBox2) && current_mouse.LeftButton == ButtonState.Pressed && click == true)
                {
                    fireOrdered = false;
                    if (loopFire == true)
                    {
                        loopReset();
                        Sound.Play("QUICKCL");
                        loopRun = 0;
                        bunnyDeclare();
                        tw.WriteLine("\n");
                        tw.WriteLine("***************************User RESET!***************************");
                        initialWrite = false;
                        activityTime.Reset();
                        sets = 3;
                    }
                    else if (loopFire == false)
                    {
                        reset();
                        tw.WriteLine("\n");
                        tw.WriteLine("***************************User RESET!***************************");
                        initialWrite = false;
                        activityTime.Reset();
                        sets = 3;
                    }
                    time3.Reset();
                    resetRun = false;
                    
                }

                if (mouseBox.Intersects(tryAgainBox2) && current_mouse.LeftButton == ButtonState.Pressed && click == true)
                {
                    fireOrdered = false;
                    resetRun = false;
                    Sound.Play("QUICKCL");
                    ammoAvailable = numEnemies;
                    numResets++;

                    if (level < 5)
                    {
                        for (int i = 0; i < bunnyHit.Length; i++)
                        {
                            bunnyHit[i] = 0;
                        }
                        loopAmmo = 1;
                        imovePossible = true;
                        resetRun = false;
                    }
                    else if (level >= 5)
                    {
                        for (int x = 0; x < bunnyHit.Length; x++)
                        {
                            bunnyHit[x] = 0;
                        }

                        for (int i = 0; i < numEnemies; i++)
                        {
                            for (int z = 0; z < i; z++)
                            {
                                if ((bunnyY[i] == bunnyY[z]) && (bunnyX[i] == bunnyX[z]))
                                {
                                    bunnyHit[z] = 1;
                                    bunnyHit[i] = 2;
                                }
                            }
                        }
                        imovePossible = true;
                        loopAmmo = 2;
                        tw.WriteLine("***************************User Reload!***************************");
                        shots = 0;
                    }

                    time3.Reset();
                    imovePossible = true;
                    ammoError = false;
                    tryAgain = false;


                    for (int x = 0; x < array_maxX; x++)
                    {
                        for (int y = 0; y < array_maxY; y++)
                        {
                            missed[x, y] = false;
                        }
                    }
                }

            }
            if (tryAgain == true)
            {

                Rectangle tryAgainRect = new Rectangle(475, fireRectPosY + 240, 100, 35);
                sprites.Draw(reloadButton, tryAgainRect, Color.White);
                BoundingBox tryAgainBox = new BoundingBox(
                    new Vector3(464, fireRectPosY + 240, 0),
                    new Vector3(564, fireRectPosY + 275, 0));
                imovePossible = false;

                if (mouseBox.Intersects(tryAgainBox) && current_mouse.LeftButton == ButtonState.Pressed && click == true)
                {
                    Sound.Play("QUICKCL");
                    ammoAvailable = numEnemies;
                    numResets++;

                    if (level < 5)
                    {
                        for (int i = 0; i < bunnyHit.Length; i++)
                        {
                            bunnyHit[i] = 0;
                        }
                        loopAmmo = 1;

                    }
                    else if (level >= 5)
                    {
                        for (int x = 0; x < bunnyHit.Length; x++)
                        {
                            bunnyHit[x] = 0;
                        }

                        for (int i = 0; i < numEnemies; i++)
                        {
                            for (int z = 0; z < i; z++)
                            {
                                if ((bunnyY[i] == bunnyY[z]) && (bunnyX[i] == bunnyX[z]))
                                {
                                    bunnyHit[z] = 1;
                                    bunnyHit[i] = 2;
                                }
                            }
                        }
                        loopAmmo = 2;
                    }
                    time3.Reset();
                    imovePossible = true;
                    ammoError = false;
                    tryAgain = false;
                    
                    for (int x = 0; x < array_maxX; x++)
                    {
                        for (int y = 0; y < array_maxY; y++)
                        {
                            missed[x, y] = false;
                        }
                    }
                    tw.WriteLine("***************************User Reload!***************************");
                    shots = 0;
                }
                        
            }
            if (tryAgainBunny == true)
            {

                Rectangle tryAgainRect = new Rectangle(475, fireRectPosY + 240, 100, 35);
                sprites.Draw(tryAgainButton, tryAgainRect, Color.White);
                BoundingBox tryAgainBox = new BoundingBox(
                    new Vector3(464, fireRectPosY + 240, 0),
                    new Vector3(564, fireRectPosY + 275, 0));
                imovePossible = false;

                if (mouseBox.Intersects(tryAgainBox) && current_mouse.LeftButton == ButtonState.Pressed)
                {
                    Sound.Play("QUICKCL");
                    imovePossible = true;
                    bunnyError = false;
                    tryAgainBunny = false;
                    time3.Reset();
                }

            }
            
            instructions();
            
            if (level > 0)
            sprites.DrawString(_font, text2, new Vector2(fireOrderRect.Left + 10, fireOrderRect.Top + 25), Color.Red);
            sprites.DrawString(_font, text3, new Vector2(fireOrderRect.Left + 10, fireOrderRect.Top + 25), Color.Blue);
            sprites.DrawString(_font, text, new Vector2(fireOrderRect.Left + 10, fireOrderRect.Top + 25), textColor);
            
        }

        //Starting instructions

        private void drawBunnies()
        {

            //*****************************Bunny Coordinate Declarations!*****************************
            
            enemyDisplay = numEnemies;            
            //***************************************Code for Bunny****************************
            int bunnyInX = 0;
            int bunnyInY = 0;



            
            for (int x = 0; x < numEnemies; x++)
            {
                bunnyArray[x] = new Bunny(bunnyX[x], bunnyY[x], "bad", enemyXcoord, enemyYcoord, content);
                bunnyArray[x].Draw(sprites, enemyXcoord, enemyYcoord);
                // levelLoad();

                if (fireSector.Intersects(bunnyArray[x].bunnyBox) && fireOrdered == true)
                {

                    if (bunnyHit[x] == 0 && strongHit == false)
                    {
                        bunnyHit[x] = 1;
                    }
                    if (bunnyHit[x] == 0 && strongHit == true)
                    {
                        bunnyHit[x] = 1;
                        strongHit = false;
                    }

                    if (bunnyHit[x] == 2 && strongHit == false)
                    {

                        strongHit = true;
                        bunnyHit[x] = 0;                 
                    }
                }
           



                    
              

                if (bunnyHit[x] < 1)
                {
                    bunnyArray[x].bunnyHit = 0;
                    bunnyArray[x].Draw(sprites, enemyXcoord, enemyYcoord);
                }
                else if (bunnyHit[x] == 2)
                {
                    bunnyArray[x].bunnyHit = 2;
                    bunnyArray[x].Draw(sprites, enemyXcoord, enemyYcoord);
                }
                else if (bunnyHit[x] == 1)
                {
                    bunnyArray[x].bunnyHit = 1;
                    bunnyArray[x].Draw(sprites, enemyXcoord, enemyYcoord);
                    enemyDisplay--;
                }


 }            


               
            if (level == 1 || level == 3)
            {
                //Checking for collisions and reset random
                for (int x = 1; x <= numEnemies; x++)
                {
                    for (int z = 0; z < x; z++)
                    {
                        if ((bunnyY[x] == bunnyY[z]) && (bunnyX[x] == bunnyX[z]))//bunnyArray[x].bunnyBox.Intersects(bunnyArray[z].bunnyBox))
                        {
                            bunnyY[z] = X.Next(5);
                            bunnyX[z] = X.Next(10);
                            x = 1;
                            minXbunny = 10;
                        }
                    }
                }
            }

            // Checking for if all bunnies are in the grid
            int bunnyPers;
            for (int y = 0; y < numEnemies; y++)
            {
                if (bunnyX[y] <= 4)
                {
                    bunnyPers = (5 - bunnyX[y]) *2;
                    if (bunnyPers <= array_maxX)
                    bunnyInX++;
                }

                if (bunnyX[y] > 4)
                {
                    bunnyPers = (bunnyX[y] - 4) * 2;
                    if (array_maxX >= bunnyPers)
                    bunnyInX++;
                }

                if (bunnyY[y] < array_maxY)
                {
                    bunnyInY++;
                }
            }

            if (bunnyInX == numEnemies && bunnyInY == numEnemies)
            {
                allIn = true;   
            }
            if (bunnyInX != numEnemies || bunnyInY != numEnemies)
            {
                allIn = false;
            }

            //**********************************End Bunny Code**********************************
        }

        // Starting Ammo and bunny Positions
        private void bunnyDeclare()
        {


            if (level == 1)
            {
                numEnemies = 5;
                loopReset();
                numEnemies = 5;
                ammoAvailable = 10;
                loopAmmo = 10;
                for (int x = 0; x < numEnemies; x++)
                {
                    bunnyX[x] = X.Next(10);
                    bunnyY[x] = 0;
                }
                randomCured = X.Next(numEnemies);

            }

            if (level == 2)
            {

               instructionArrow = false;
               array_maxY = 1;
               array_maxX = 10;

                

                    xIncrease = X.Next(5);
                    xStart = X.Next(3);
                if (xIncrease == 0)
                {
                    xIncrease = X.Next(4);
                    if (xIncrease == 0)
                    {
                        xIncrease = 1;
                    }
                }


                enemies = 0;
                for (int x = xStart; x < array_maxX; x += xIncrease)
                {
                    enemies++;
                }

                numEnemies = enemies;


                    

                    
                for (int x = xStart; x < array_maxX; x += xIncrease)
                {
                    bunnyX[bunny] = x;
                    bunnyY[bunny] = 0;
                    bunny++;
                }
                ammoAvailable = numEnemies;
                loopAmmo = 1;

                randomCured = X.Next(stage0enemies + stage1enemies + stage2enemies);
                for (int x = 0; x < numEnemies; x++)
                {
                    if (bunnyX[x] >= maxXbunny)
                        maxXbunny = bunnyX[x];
                }

            }
            if (level == 3)
            {
                numEnemies = 10;
                ammoAvailable = numEnemies + 2;
                for (int x = 0; x < numEnemies; x++)
                {
                    bunnyX[x] = X.Next(10);
                    bunnyY[x] = X.Next(5);
                }
                randomCured = X.Next(numEnemies);
            }

            if (level == 4)
            {

                array_maxY = 5;
                array_maxX = 10;
                xIncrease = X.Next(5);
                if (xIncrease == 0)
                {
                    xIncrease = 1;
                }
                xStart = X.Next(4);

                yStart = X.Next(2);
                yIncrease = X.Next(4);
                if (yIncrease == 0)
                {
                    yIncrease = 1;
                }


                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {
                        enemies++;
                    }
                }
                numEnemies = enemies;
                ammoAvailable = numEnemies;
                loopAmmo = 1;
                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {
                        bunnyX[bunny] = x;
                        bunnyY[bunny] = y;
                        bunny++;
                    }
                }
                randomCured = X.Next(stage0enemies + stage1enemies + stage2enemies);

            }

            if (level == 5)
            {
                loopReset();
                array_maxY = 5;
                array_maxX = 10;
                xIncrease = X.Next(5);
                if (xIncrease == 0)
                {
                    xIncrease = 1;
                }
                xStart = X.Next(4);

                yStart = X.Next(4);
                yIncrease = X.Next(4);

                if (yIncrease == 0)
                {
                    yIncrease = 1;
                }


                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {
                        enemies++;
                    }
                }
                numEnemies = enemies;
                
                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {
                        bunnyX[bunny] = x;
                        bunnyY[bunny] = y;
                        bunny++;
                    }
                }
                logXstart = xStart;
                logXincrease = xIncrease;
                logYstart = yStart;
                logYincrease = yIncrease;
                ///////////////////////////////////////////////
                xIncrease = X.Next(5);
                if (xIncrease == 0)
                {
                    xIncrease = 1;
                }
                xStart = X.Next(4);
                yStart = X.Next(4);
                yIncrease = X.Next(4);

                if (yIncrease == 0)
                {
                    yIncrease = 1;
                }

                enemies2 = 0;

                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {
                        enemies2++;
                    }
                }
                numEnemies = enemies2 + enemies;
                ammoAvailable = numEnemies;
                loopAmmo = 2;
                for (int y = yStart; y < array_maxY; y += yIncrease)
                {

                    for (int x = xStart; x < array_maxX; x += xIncrease)
                    {

                        bunnyX[bunny] = x;
                        bunnyY[bunny] = y;
                        bunny++;

                    }
                }
                logXstart2 = xStart;
                logXincrease2 = xIncrease;
                logYstart2 = yStart;
                logYincrease2 = yIncrease;
                // Checking for collisions
                for (int i = 0; i < numEnemies; i++)
                {
                    for (int z = 0; z < i; z++)
                    {
                        if ((bunnyY[i] == bunnyY[z]) && (bunnyX[i] == bunnyX[z]))
                        {
                            bunnyHit[z] = 1;
                            bunnyHit[i] = 2;
                        }
                    }
                }

                if (firstRun == true)
                {
                    

                    newLine15 = true;
                    firstRun = false;
                }

                randomCured = X.Next(stage0enemies + stage1enemies + stage2enemies);
            }
        
        }

        private void firePositioning()
{
    loopButtonRect = new Rectangle(395, 430, 110, 35);

            loopButtonBox = new BoundingBox(
             new Vector3((395), (430), (0)),
             new Vector3((505), (540), (0))
                );

        loopButton = loopButtonStandard;
            BoundingBox mouseBox = new BoundingBox(
    new Vector3(
        (mouseX - 1), (mouseY - 1), (0)),
    new Vector3(
        (mouseX + 1), (mouseY + 1), (0))
        );

            
            fireButton2x = (resolutionWidth - resolutionWidth / 3);
            fireButton2y = ((resolutionHeight - (resolutionHeight / 3) + 50) + fireControl.Height / 3);
            fireButton1x = fireButton2x + 50;
            fireButton1y = fireButton2y;
            fireButton1Rect = new Rectangle(fireButton1x, fireButton1y, 20, 30);
            sprites.Draw(dial1Button, fireButton1Rect, Color.White);

            //Fire and Reset Bounding Boxes
            BoundingBox fireBox = new BoundingBox(
                new Vector3(
                    (272),
                    (449),
                    (0)),
                new Vector3(
                    (347),
                    (470),
                    (0))
                        );

            resetBox = new BoundingBox(
                new Vector3(
                    (272),
                    (484),
                    (0)),
                new Vector3(
                    (347),
                    (506),
                    (0))
                      );



            // X left and right BBoxes
            BoundingBox fireButtonUp1 = new BoundingBox(
                 new Vector3(
                     (fireButton1x),
                     (fireButton1y),
                     (0)),
                 new Vector3(
                     (fireButton1x + 20),
                     (fireButton1y + 14),
                     (0)
                     )
                     );

            BoundingBox fireButtonDown1 = new BoundingBox(
                 new Vector3(
                     (fireButton1x),
                     (fireButton1y + 15),
                     (0)),
                  new Vector3(
                     (fireButton1x + 20),
                     (fireButton1y + 30),
                     (0)
                     )
                     );
            // Y up and down BBoxes

            if (level > 1)
            {
                fireButton2Rect = new Rectangle(fireButton2x, fireButton2y, 20, 30);
                sprites.Draw(dial2Button, fireButton2Rect, Color.White);

                BoundingBox fireButtonUp2 = new BoundingBox(
                   new Vector3(
                       (fireButton2x),
                       (fireButton2y),
                       (0)),
                   new Vector3(
                       (fireButton2x + 20),
                       (fireButton2y + 14),
                       (0)
                       )
                       );
                BoundingBox fireButtonDown2 = new BoundingBox(
                    new Vector3(
                        (fireButton2x),
                        (fireButton2y + 15),
                        (0)),
                     new Vector3(
                        (fireButton2x + 20),
                        (fireButton2y + 30),
                        (0)
                        )
                        );
                if ((mouseBox.Intersects(fireButtonUp2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine7 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine7 == true)
                    {
                        if (movePossible == true)
                            targetPosY++;
                        if (targetPosY < array_maxY && targetPosY > 0)
                            Sound.PlayTurn();

                        if (targetPosY >= array_maxY)
                        {
                            Sound.Play("TICK");
                            targetPosY -= 1;
                        }
                        newLine7 = false;

                    }
                }

                if ((mouseBox.Intersects(fireButtonDown2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine8 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine8 == true)
                    {
                        if (movePossible == true)
                            targetPosY--;
                        if (targetPosY <= 0)
                        {
                            targetPosY = 0;
                            Sound.Play("TICK");
                        }
                        if (targetPosY < array_maxY && targetPosY > 0)
                            Sound.PlayTurn();

                        newLine8 = false;
                    }

                }


            }
            //hitDefault change on click.

            if ((mouseBox.Intersects(fireButtonUp1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine5 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine5 == true)
                {
                    if (movePossible == true)
                    targetPosX++;
                    if (targetPosX < array_maxX && targetPosX > 0)
                        Sound.PlayTurn();
                    
                    if (targetPosX >= array_maxX)
                        {
                         Sound.Play("TICK");
                         targetPosX = targetPosX - 1;
                        }
                    
                
                    newLine5 = false;

                }
            }

            if ((mouseBox.Intersects(fireButtonDown1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine6 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine6 == true)
                {
                    if (movePossible == true)
                    targetPosX--;
                    if (targetPosX <= 0)
                        {
                    targetPosX = 0;
                    Sound.Play("TICK");
                        }
                    
                    if (targetPosX < array_maxX && targetPosX > 0)
                      Sound.PlayTurn();
                    newLine6 = false;
                }

            }

            if ((mouseBox.Intersects(fireBox)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
            {
                newLine9 = true;
                current_mouse = Mouse.GetState();
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine9 == true)
                {
                    
                    if (allIn == true && ammoAvailable > 0)
                    {
                        //Sound.Play("implosion");
                        Sound.PlayImplosion();
                        fireOrdered = true;
                        ammoAvailable--;
                        time.Start();
                        movePossible = false;
                        newLine9 = false;
                    }
                    if (allIn == false)
                    {
                        bunnyError = true;
                        //click = true;
                    }
                    if (ammoAvailable <= 0)
                    {
                        ammoError = true;
                    }
              }
            newLine9 = false;
            }


            if ((mouseBox.Intersects(resetBox)) && (current_mouse.LeftButton == ButtonState.Pressed))
            {
                newLine10 = true;
                current_mouse = Mouse.GetState();
                
            }
            else if ((current_mouse.LeftButton == ButtonState.Released))
            {
                if (newLine10 == true)
                {
                    if (resetRun == true)
                    {
                        resetRun = false;
                        newLine10 = false;
                    }
                    else if (resetRun == false)
                    {
                        resetRun = true;
                        newLine10 = false;
                    }
                    //reset();
                }
                //newLine10 = false;
            }


            if (targetPosX >= array_maxX)
                targetPosX = targetPosX - 1;
            if (targetPosX < 0)
                targetPosX = 0;
            if (targetPosY >= array_maxY)
                targetPosY = targetPosY - 1;
            if (targetPosY < 0)
                targetPosY = 0;


            if (level == 1)
            {
                sprites.DrawString(_font, "fire_on ",
    new Vector2(
    (fireButton1x - 100), fireButton1y + 5), Color.Red);

                sprites.DrawString(_font, Convert.ToString(targetPosX),
                        new Vector2(
                        (fireButton1x - 15), fireButton1y + 5), Color.Navy);
                sprites.DrawString(_font, "[    ] = 1;",
                          new Vector2(
                          (fireButton1x - 20), fireButton2y + 3), Color.Red);
            }

            if (level > 1)
            {
                sprites.DrawString(_font, "fire_on ",
                    new Vector2(
                    (fireButton2x - 100), fireButton2y + 5), Color.Red);
            
            sprites.DrawString(_font, Convert.ToString(targetPosX),
                    new Vector2(
                    (fireButton1x - 15), fireButton1y + 5), Color.Navy);
                sprites.DrawString(_font, Convert.ToString(targetPosY),
                        new Vector2(
                        (fireButton2x - 15), fireButton2y + 5), Color.MediumVioletRed);

                sprites.DrawString(_font, "[    ]",
                        new Vector2(
                        (fireButton2x - 20), fireButton2y + 3), Color.Red);
                sprites.DrawString(_font, "[    ] = 1;",
                        new Vector2(
                        (fireButton1x - 20), fireButton1y + 3), Color.Red);
            }
            target.X = hitDefault.X + (75 * targetPosX);
            target.Y = hitDefault.Y + (75 * targetPosY);

            fireSector = new BoundingBox(
                new Vector3((target.X), (target.Y), (0)),
                new Vector3((target.X + 15), (target.Y + 15), (0))
                ); 
            if (fireOrdered == true)
            {
                
                if (time.Elapsed.Milliseconds < 750)
                {
                    
                    explosion.Position.X = target.X + 15;
                    explosion.Position.Y = target.Y + 15;
               }     
                if (time.Elapsed.Milliseconds >= 750)
                    {
                    
                        fireOrdered = false;
                        movePossible = true;
                       // targetPosX = 0;
                      //  targetPosY = 0;
                        newLine10 = false;


                        Logging();

                        // close the stream
                        
                    
                        time.Stop();
                        time.Reset();
                    }
                    
            }



            //if ((mouseBox.Intersects(loopButtonBox)) && (current_mouse.LeftButton == ButtonState.Pressed))
            //{
            //    newLine15 = true;
            //    current_mouse = Mouse.GetState();
            //}
            //else if ((current_mouse.LeftButton == ButtonState.Released))
            //{
            //    if (newLine15 == true)
            //    {
            //        loopFire = true;
            //        newLine15 = false;
            //    }

            //}

         
            //********************************End Fire Code****************************

sprites.Draw(loopButton, loopButtonRect, Color.White);
        
        }

        private void Logging()
        {
            if (level == 1  || level == 3)
            {
                // write a line of text to the file
                int newX;
                if (enemyDisplay == enemyCount)
                {
                    correct = false;
                }
                else if (enemyDisplay != enemyCount)
                {
                    correct = true;
                    enemyCount = enemyDisplay;
                }
                if (initialWrite == false)
                {
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("New level or Activity!");
                    tw.WriteLine(DateTime.Now);
                    tw.WriteLine("Level: " + level);
                    tw.WriteLine("Task: "+activity);
                    tw.WriteLine("Array size: " + array_maxX);
                    for (int x = 0; x < numEnemies; x++)
                    {

                        newX = bunnyArray[x].bunnyX - ((10 - array_maxX) / 2);
                        tw.WriteLine("Element " + x + ": " + "{y:" + bunnyArray[x].bunnyY + ", x:" + newX + "}");
                    }
                    initialWrite = true;
                }
                tw.WriteLine("\n");
                tw.WriteLine("***********************************");
                tw.WriteLine("\n\nUser Input at Time:");
                tw.WriteLine("Overall time: "+overallTime.Elapsed);
                tw.WriteLine("Level Time: " + levelTime.Elapsed);
                tw.WriteLine("Time on Current Activity: "+activityTime.Elapsed);
                tw.WriteLine("\n");
                tw.WriteLine("User Input:");
                tw.WriteLine("int fire_on[" + targetPosX+"]["+targetPosY+"];");
                tw.WriteLine("Correct Shot: "+correct);
                tw.WriteLine("Elements Remaining: " + enemyDisplay);
                if (correct == true && enemyDisplay == 0)
                {
                    tw.WriteLine("Time to complete activity: " + activityTime.Elapsed);
                    
                }
            }
            else if (level == 2  || level == 4)
            {
                if (initialWrite == false)
                {
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("New level or Activity!");
                    tw.WriteLine(DateTime.Now);
                    tw.WriteLine("Level: "+level);
                    tw.Write("Task: " + activity);
                    initialWrite = true;
                }
                tw.WriteLine("\n");
                tw.WriteLine("***********************************");
                tw.WriteLine("\n\nUser Input at Time:");
                tw.WriteLine("Overall time: " + overallTime.Elapsed);
                tw.WriteLine("Level Time: " + levelTime.Elapsed);
                tw.WriteLine("Time on Current Activity: " + activityTime.Elapsed);
                tw.WriteLine("\n");
                tw.WriteLine("User Input:");
                tw.WriteLine("for (int y = " + loopIndexY + "; y <= " + loopYmax + "; y += " + increaseNumY + ";)");
                tw.WriteLine("    for (int x = "+loopIndex+"; x <= "+loopXmax+"; x += "+increaseNum+";)");
                tw.WriteLine("Correct Loop: " + correct);
                if (correct == true)
                {
                    tw.WriteLine("Time to complete activity: " + activityTime.Elapsed);
                }
                tw.WriteLine("Sets Remaining: " + sets);
            }
            else if (level == 5)
            {
                if (initialWrite == false)
                {
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("\n");
                    tw.WriteLine("New level or Activity!");
                    tw.WriteLine(DateTime.Now);
                    tw.WriteLine("Level: " + level);
                    tw.Write("Task: " + activity);
                    initialWrite = true;
                }
                tw.WriteLine("\n");
                tw.WriteLine("***********************************");
                tw.WriteLine("\n\nUser Input at Time:");
                tw.WriteLine("Overall time: " + overallTime.Elapsed);
                tw.WriteLine("Level Time: " + levelTime.Elapsed);
                tw.WriteLine("Time on Current Activity: " + activityTime.Elapsed);
                tw.WriteLine("\n");
                tw.WriteLine("User Input:");
                tw.WriteLine("for (int y = " + loopIndexY + "; y <= " + loopYmax + "; y += " + increaseNumY + ";)");
                tw.WriteLine("    for (int x = " + loopIndex + "; x <= " + loopXmax + "; x += " + increaseNum + ";)");
                if (shots == 1)
                {
                    tw.WriteLine("Correct Loops: N/A - Loop 1 of 2");
                }
                if (shots == 2)
                {
                    tw.WriteLine("Correct Loops: "+ correct);
                }
                if (correct == true)
                {
                    tw.WriteLine("Time to complete activity: " + activityTime.Elapsed);
                    shots = 0;
                }
                tw.WriteLine("Sets Remaining: " + sets);
            }

        }

        private void reset()
        {
            for (int x = 0; x < array_maxX; x++)
            {
                for (int y = 0; y < array_maxY; y++)
                {
                    missed[x, y] = false;
                }
            }
            Sound.Play("QUICKCL");
            fireOrdered = false;
            movePossible = true;
            targetPosX = 0;
            targetPosY = 0;
            //array_maxX = 1;
            //array_maxY = 1;
            newLine10 = false;
            time.Stop();
            time.Reset();
            for (int i = 0; i < bunnyHit.Length; i++)
            {
                bunnyHit[i] = 0;
            }
            bunny = 0;
            bunnyError = false;
            ammoError = false;
            array_maxX = 1;
            array_maxY = 1;
            instructionSequence = 1;
            //numResets = 0;
            bunnyDeclare();


        }

        private void controls()
        {
                BoundingBox mouseBox = new BoundingBox(
    new Vector3(
        (mouseX - 1), (mouseY - 1), (0)),
    new Vector3(
        (mouseX + 1), (mouseY + 1), (0))
        );
            // Draw fireControl Box

            Rectangle fireControlRect = new Rectangle(0, resolutionHeight - (resolutionHeight / 3) + 7, resolutionWidth, resolutionHeight / 3);
            sprites.Draw(fireControl, fireControlRect, Color.White);

            BoundingBox ControlBox = new BoundingBox(
                new Vector3(105, resolutionHeight - (resolutionHeight / 3) + 7, 0),
                new Vector3(695, resolutionHeight, 0)
            );
            BoundingBox instructionBox = new BoundingBox(
                new Vector3(381, fireRectPosY, 0),
                new Vector3(680, resolutionHeight - (resolutionHeight / 3) + 7, 0)
            );

            if (mouseBox.Intersects(ControlBox) || mouseBox.Intersects(instructionBox))
            {
                mouseimg = mouseimg2;
            }
            if (mouseBox.Intersects(ControlBox) == false && mouseBox.Intersects(instructionBox) == false)
            {
                mouseimg = mouseimg1;
            }

           



                int button2x = (resolutionWidth - resolutionWidth / 3);
                int button2y = ((resolutionHeight - (resolutionHeight / 3) + 5) + fireControl.Height / 3);
                int button1x = button2x + 50;
                int button1y = button2y;

                if (movePossible == false && current_mouse.LeftButton == ButtonState.Pressed && mouseBox.Intersects(ControlBox) && mouseBox.Intersects(resetBox) == false && mouseBox.Intersects(fireOrderBox) == false && mouseBox.Intersects(soundBox) == false)
                {
                    errorClick = true;

                }
                if (errorClick == true && current_mouse.LeftButton == ButtonState.Released && mouseBox.Intersects(resetBox) == false && mouseBox.Intersects(fireOrderBox) == false && mouseBox.Intersects(soundBox) == false)
                    {
                        Sound.Play("errorBeep2");
                        errorClick = false;
                    }

            if (loopFire == false)
            {
                dialButton1Rect = new Rectangle(button1x, button1y, 20, 30);
                sprites.Draw(dial1Button, dialButton1Rect, Color.White);

                // Up and down Array X coords Bounding Boxes
                BoundingBox buttonUp1 = new BoundingBox(
                     new Vector3(
                         (button1x),
                         (button1y),
                         (0)),
                     new Vector3(
                         (button1x + 20),
                         (button1y + 14),
                         (0)
                         )
                         );

                BoundingBox buttonDown1 = new BoundingBox(
                     new Vector3(
                         (button1x),
                         (button1y + 15),
                         (0)),
                      new Vector3(
                         (button1x + 20),
                         (button1y + 30),
                         (0)
                         )
                         );
                //Up and down Array Y
                BoundingBox buttonUp2 = new BoundingBox(
                    new Vector3(
                        (button2x),
                        (button2y),
                        (0)),
                    new Vector3(
                        (button2x + 20),
                        (button2y + 14),
                        (0)
                        )
                        );
                BoundingBox buttonDown2 = new BoundingBox(
                    new Vector3(
                        (button2x),
                        (button2y + 15),
                        (0)),
                     new Vector3(
                        (button2x + 20),
                        (button2y + 30),
                        (0)
                        )
                        );

                if (array_maxX <= 0)
                    array_maxX = 1;

                if (array_maxY <= 0)
                    array_maxY = 1;

                //Increase/ decrease Array size X
                if ((mouseBox.Intersects(buttonUp1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released) && movePossible == true)
                {
                    if (newLine == true)
                    {
                        if (movePossible == true)
                        {
                            array_maxX++;
                            if (array_maxX > 10)
                            {
                                array_maxX = 10;
                            }

                            if (array_maxY <= 0)
                            { array_maxY++; }
                            Sound.Play("QUICKCL");
                            newLine = false;
                        }
                    }
                }

                if ((mouseBox.Intersects(buttonDown1)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine2 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine2 == true)
                    {
                        if (movePossible == true)
                        {
                            array_maxX--;
                            Sound.Play("QUICKCL");
                            newLine2 = false;
                        }
                    }

                }

                // Increase / decrease array size Y
                if ((mouseBox.Intersects(buttonUp2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine3 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine3 == true)
                    {
                        if (movePossible == true)
                        {
                            array_maxY++;
                            if (array_maxY > 5)
                            {
                                array_maxY = 5;
                            }
                            Sound.Play("QUICKCL");
                            if (array_maxX <= 0)
                            { array_maxX++; }
                            newLine3 = false;
                        }
                    }
                }

                if ((mouseBox.Intersects(buttonDown2)) && (current_mouse.LeftButton == ButtonState.Pressed) && movePossible == true)
                {
                    newLine4 = true;
                    current_mouse = Mouse.GetState();
                }
                else if ((current_mouse.LeftButton == ButtonState.Released))
                {
                    if (newLine4 == true)
                    {
                        if (movePossible == true)
                        {
                            array_maxY--;
                            Sound.Play("QUICKCL");
                            newLine4 = false;
                        }
                    }

                }







                if (level == 1)
                {
                    sprites.DrawString(_font, "int fire_on [     ];",
                            new Vector2(
                            (button1x - 125), button1y + 5), Color.Red);
                    sprites.DrawString(_font, "           " + array_maxX,
                new Vector2(
                (button1x - 117), button1y + 5), Color.Navy);
                }
                if (level > 1)
                {
                    sprites.DrawString(_font, "int fire_on [    ]",
                        new Vector2(
                        (button2x - 125), button2y + 5), Color.Red);
                    sprites.DrawString(_font, "           " + array_maxX,
                new Vector2(
                (button1x - 117), button1y + 5), Color.Navy);

                    sprites.DrawString(_font, "[    ];",
                            new Vector2(
                            (button1x - 20), button1y + 5), Color.Red);
                    sprites.DrawString(_font, "            " + array_maxY,
                    new Vector2(
                        (button2x - 120), button2y + 5), Color.MediumVioletRed);
                    Rectangle dialButton2Rect = new Rectangle(button2x, button2y, 20, 30);
                    sprites.Draw(dial2Button, dialButton2Rect, Color.White);
                }
            }
            else if (loopFire == true)
            {
                sprites.DrawString(_font, "int fire_on ["+ array_maxX+"]"+" ["+array_maxY+"];",
                            new Vector2(
                            (button1x - 125), button1y + 5), Color.Red);
            }

        
        }

        private void instructionarrows()
        {
            if (instructionArrow == true && click == true)
            {
                
                if (allIn == false)
                {
                    Rectangle instructionRect = new Rectangle(dialButton1Rect.X + 20, dialButton1Rect.Y - 40, 20, 40);
                    Rectangle instructionRect2 = new Rectangle(dialButton1Rect.X + 20, dialButton1Rect.Y - 55, 30, 50);
                    flashTime.Start();
                    if (flashTime.Elapsed.Milliseconds < 500)
                    {
                        sprites.Draw(arrowPointer, instructionRect, Color.White);
                    }
                    if (flashTime.Elapsed.Milliseconds > 500)
                    {
                        sprites.Draw(arrowPointer, instructionRect2, Color.White);
                    }
                    if (flashTime.Elapsed.Milliseconds > 1000)
                    {
                        flashTime.Stop();
                        flashTime.Reset();
                    }
                }
                if (allIn == true)
                {

                    Rectangle instructionRect3 = new Rectangle(Convert.ToInt16(target.X + 29), Convert.ToInt16(target.Y - 60) + 15, 20, 40);
                    Rectangle instructionRect4 = new Rectangle(Convert.ToInt16(target.X + 29), Convert.ToInt16(target.Y - 60), 30, 50);
                    Rectangle instructionRect = new Rectangle(dialButton1Rect.X + 20, dialButton1Rect.Y +15, 20, 40);
                    Rectangle instructionRect2 = new Rectangle(dialButton1Rect.X + 20, dialButton1Rect.Y, 30, 50);
                    flashTime.Start();
                    if (flashTime.Elapsed.Milliseconds < 500)
                    {
                        sprites.Draw(arrowPointer, instructionRect3, Color.White);
                        sprites.Draw(arrowPointer, instructionRect, Color.White);
                    }
                    if (flashTime.Elapsed.Milliseconds > 500)
                    {
                        sprites.Draw(arrowPointer, instructionRect4, Color.White);
                        sprites.Draw(arrowPointer, instructionRect2, Color.White);
                    }
                    if (flashTime.Elapsed.Milliseconds > 1000)
                    {
                        flashTime.Stop();
                        flashTime.Reset();
                    }
                }

            }
            if (instructionArrow2 == true && click == true)
            {
                Rectangle instructionRect = new Rectangle(fireButton1x + 105, fireButton3y - 5, 20, 40);
                Rectangle instructionRect2 = new Rectangle(fireButton1x + 105, fireButton3y - 20, 30, 50);
                flashTime.Start();
                if (flashTime.Elapsed.Milliseconds < 500)
                {
                    sprites.Draw(arrowPointer, instructionRect, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 500)
                {
                    sprites.Draw(arrowPointer, instructionRect2, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 1000)
                {
                    flashTime.Stop();
                    flashTime.Reset();
                }
            }
            if (instructionArrow3 == true && click == true)
            {
                Rectangle instructionRect = new Rectangle(fireButton1x + 10, fireButton3y - 5, 20, 40);
                Rectangle instructionRect2 = new Rectangle(fireButton1x + 10, fireButton3y - 20, 30, 50);
                Rectangle instructionRect3 = new Rectangle(fireButton1x + 190, fireButton3y - 5, 20, 40);
                Rectangle instructionRect4 = new Rectangle(fireButton1x + 190, fireButton3y - 20, 30, 50);

                flashTime.Start();
                if (flashTime.Elapsed.Milliseconds < 500)
                {
                    sprites.Draw(arrowPointer, instructionRect, Color.White);
                    sprites.Draw(arrowPointer, instructionRect3, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 500)
                {
                    sprites.Draw(arrowPointer, instructionRect2, Color.White);
                    sprites.Draw(arrowPointer, instructionRect4, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 1000)
                {
                    flashTime.Stop();
                    flashTime.Reset();
                }

            }
            if (instructionArrow4 == true && click == true)
            {
                Rectangle instructionRect = new Rectangle(220, 480, 60, 30);
                Rectangle instructionRect2 = new Rectangle(221, 476, 80, 40);
                flashTime.Start();
                if (flashTime.Elapsed.Milliseconds < 500)
                {
                    sprites.Draw(arrowPointerSide, instructionRect, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 500)
                {
                    sprites.Draw(arrowPointerSide, instructionRect2, Color.White);
                }
                if (flashTime.Elapsed.Milliseconds > 1000)
                {
                    flashTime.Stop();
                    flashTime.Reset();
                }
            }
            if (instructionArrow5 == true && click == true)
            {
                Rectangle instructionRect = new Rectangle(600, fireRectPosY + 80, 60, 80);
                if (fireRectPosY < 260)
                {
                    sprites.Draw(strongBunny, instructionRect, Color.White);
                }
            }


        }

        private void instructions()
        {
            if (fireOrdered == true)
            {
                imovePossible = false;
            }
            if (imovePossible == false)
            {
                movePossible = false;
            }
            if (imovePossible == true)
            {

                movePossible = true;
            }

            //////////Ammo Error click
            
            if (ammoError == true)
            {
            time3.Start();

                if (time3.Elapsed.Seconds < 1)
                {
                    click = true;
                    tryAgain = true;
                }
                if (time3.Elapsed.Seconds > 1)
                {
                    time3.Stop();

                }
            }
            if (resetRun == true)
            {
                time3.Start();

                if (time3.Elapsed.Seconds < 1)
                {
                    click = true;
                }
                if (time3.Elapsed.Seconds > 1)
                {
                    time3.Stop();

                }
            }
            if (ammoError == false)
            {
                tryAgain = false;
            }
            if (bunnyError == true)
            {
                time3.Start();

                if (time3.Elapsed.Seconds < 1)
                {
                    click = true;
                }

                if (time3.Elapsed.Seconds > 1)
                {
                    time3.Stop();
                }
            }

        level1instr();
        level2instr();
        level3instr();
        level4instr();
        level5instr();
   
        }
            private void level1instr()
        {
            if (level == 1)
            {
                levelTime.Start();
                activityTime.Start();
                activity = "Write code to fill the following elements of this array with '1'";
                for (int x = 0; x < numEnemies; x++)
                {
                    if (bunnyX[x] >= maxXbunny)
                    {
                        maxXbunny = bunnyX[x];
                    }
                    else if (bunnyX[x] < minXbunny)
                    {
                        minXbunny = bunnyX[x];
                    }
                }
                if ((maxXbunny - 4) < (5 - minXbunny))
                {
                    bunnyHint = 10 - (2 * minXbunny);
                }

                else if ((maxXbunny - 4) >= (5 - minXbunny))
                {
                    bunnyHint = (maxXbunny - 4) * 2;
                    
                }
                //else if ((maxXbunny - 4) == (5 - minXbunny))
                //{
                //    bunnyHint = (maxXbunny - 4) * 2;
                //}
                if (instructionSequence != 4)
                {
                    text3 = " ";
                }
                time2.Start();
                if (time2.Elapsed.Seconds < 1)
                {
                    click = true;
                    instructionSequence = 1;
                    previousSequence = 1;

                }
                if (time2.Elapsed.Seconds > 1)
                {
                    time2.Stop();
                }
                text2 = " ";
                text3 = " ";


                if (instructionSequence == 1)
                {
                    GoOnVisible = true;
                    GoBackVisible = false;
                    text = "  Welcome to Bunny Arrayser!  \nSoldier, there has been an \noutbreak of mutant bunnies all \nover America!  You have been \ntasked with curing these poor \ncreatures.  At your disposal is\nthe Bunny Arrayser, a very\nadvanced and sophisticated\nartillery machine. \n";
                    imovePossible = false;
                    goOnFlash = true;
                    click = true;
                    instructionArrow = false;
                    instructionArrow4 = false;

                }
                else if (instructionSequence == 2)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    text = "To use the Bunny Arrayser,\nhowever, requires a knowledge\nof how to use arrays.\n  Arrays are a group elements \nof the same type that can be \naccessed using an identifier.  \n  Think about arrays like a row \nof mailboxes. The street name \nis like the array name, and the \naddress is like the identifier.";
                    click = true;
                    instructionArrow = false;
                    imovePossible = false;
                }
                else if (instructionSequence == 3)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    text = "The Bunny Arrayser cannon \nuses an array of type 'int.' \n1 is an order to fire, and \n0 is an order to hold fire.\n  In C++, and on this cannon, \narrays are declared by giving \na type (int, float, string, etc.), \na name, and then enclosing the \narray size in square brackets[]. ";
                    click = true;
                    instructionArrow = false;
                    imovePossible = false;
                }
                else if (instructionSequence == 4)
                {
                    GoOnVisible = false;
                    GoBackVisible = true;
                    text = "  Below on the control panel,\nthe array 'fire_on []'\nis declared for you.\n  Your task is to now use the\narrow button below to increase\nthe array size (in '[ ]') to a\nsize that is large enough \nto hold all of the elements \n(the evil red bunnies above).";
                    text3 = "\n\n\n\n\n\n\n\n\nHint: An array size of "+ (bunnyHint) +" \n          is needed!";
                    if (allIn == false)
                    {
                        instructionArrow = true;
                        GoOnVisible = false;
                        imovePossible = true;
                        instructionArrow4 = false;
                    }
                    else if (allIn == true)
                    {
                        instructionArrow = false;
                        text = "Great!\nNotice how the array starts\n at 0, not 1. This is crucial to \nremember! For example, an \narray initialized as \n'int fire_on[5]' \nwill be numbered 0 to 4! \nThis becomes especially \nimportant while filling \narrays with loops.";
                        text3 = " ";
                        GoOnVisible = true;
                        imovePossible = false;
                        goOnFlash = true;
                    }

                    click = true;
                }


                else if (instructionSequence == 5)
                {
                    text = "Now use the buttons \nbelow to change your firing \nposition. The statement \n'fire_on [x] = 1;' \nwill use 'x' as the index for \nthe array.  By pressing the \n'Fire!' button you will fill that \nelement of the array with '1', \nand the cannon will fire on 'x'.";
                    
                    GoOnVisible = true;
                    goOnFlash = false;
                    instructionArrow = true;
                    imovePossible = true;
                    click = true;
                    goOn = goOn1;
                    instructionArrow4 = false;
                    if (allIn == false)
                    {
                        instructionSequence = 4;
                    }
                    if (enemyDisplay < 5 && instrucInc == true)
                    {

                        instructionSequence = 6;
                        instrucInc = false;
                    }

                }

                else if (instructionSequence == 6)
                {
                    text = "Cure all of the bunnies \nto move on to the \nnext mission!\n\nNote: You may now open or \nclose this instruction panel \nby clicking the yellow \n'Instructions' button below.";
                    GoOnVisible = false;
                    imovePossible = true;
                    instructionArrow = true;
                    instructionArrow4 = false;
                    if (allIn == false)
                    {
                        instructionSequence = 4;
                    }

                }
                if (bunnyError == true || ammoError == true || resetRun == true)
                {
                    errors();
                }

            }
        }
            private void level2instr()
        {
            if (level == 2)
            {
                levelTime.Start();
                time2.Start();
                if (time2.Elapsed.Seconds < 1)
                {
                    click = true;
                    instructionSequence = 1;
                    previousSequence = 1;
                    activityTime.Start();

                }
                if (time2.Elapsed.Seconds > 1)
                {
                    time2.Stop();
                }
                text2 = " ";
                text3 = " ";
                for (int x = 0; x < numEnemies; x++)
                {
                    if (bunnyX[x] >= maxXbunny)
                    {
                        maxXbunny = bunnyX[x];
                    }
                }

                if (instructionSequence == 1)
                {
                    GoOnVisible = true;
                    GoBackVisible = false;
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    imovePossible = false;
                    click = true;
                    goOnFlash = true;
                    instructionArrow4 = false;
                    text = "     Great job, Soldier!  \nBut there's still work to do! \nThe bunnies here are arranged \nin a pattern! This is the\nperfect time to use the loop \nfire option of the cannon!\nBefore, you were filling the \narray manually.  However, \nloops can be used to do the \njob faster and easier!";
                }
                else if (instructionSequence == 2)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    instructionArrow4 = true;
                    imovePossible = false;
                    click = true;
                    goOnFlash = true;
                    text = "Note: You need to start \nkeeping an eye on your \nammunition!  We are often \nsupplied with only enough for \none shot per bunny, so be \ncareful!  'Ammo' is the total \nnumber of shots you can take,\nand 'Loops' is the number \nof loops you can currently run.";
                }
                else if (instructionSequence == 3)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    imovePossible = false;
                    goOnFlash = true;
                    click = true;
                    instructionArrow4 = false;
                    text = "You should have some \nknowledge of loops, but we'll \nreview just to be sure!  \n'for loops' start by setting an \ninitial start value. Here, it is 'c.'  \nThen, the value is incremented \nby a given number (shown by \n'c += ?') until it reaches the \nmaximum ('c < ?'). ";
                }
                else if (instructionSequence == 4)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    imovePossible = false;
                    goOnFlash = true;
                    instructionArrow4 = false;
                    click = true;
                    text = "The starting position of the\nloop is given first.\nThis is the initial point where \nthe loop fire will begin. \nNext is the maximum.  This \nis the value at which the loop \nwill stop. Notice that this loop\nuses '<' and not '<=', so the\nloop will stop at '9' if \nthe maximum is set to 'c < 10.'";

                }
                else if (instructionSequence == 5)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    imovePossible = false;
                    click = true;
                    goOnFlash = true;
                    text = "Incrementing the index \ndetermines how much the \nvalue will increase for each \nrun of the loop. \nFor example, incrementing 'c' \nby 2 (setting 'c += 2') \nwill hit every other element\nin the array.\n'c += 3' will hit every third,\nand so on.";
                }
                else if (instructionSequence == 6)
                {
                    //GoOnVisible = true;
                    GoBackVisible = true;
                    click = true;
                    text = "These values are all \ndependent upon each other,\nso changing one may allow \nyou to change the others.";
                    text3 = "\n\n\n\n\nStart by setting the maximum\nvalue to an appropriate \nnumber. ";
                    instructionArrow2 = true;
                    instructionArrow3 = false;
                    if (loopXmax > maxXbunny)
                    {
                        GoOnVisible = true;
                        text = "That should do it!\n\nMove on for further\ninstruction!";
                        imovePossible = false;
                        instructionArrow2 = false;
                        text3 = "";
                    }
                    else if (loopXmax <= maxXbunny)
                    {
                        GoOnVisible = false;
                        imovePossible = true;
                        instructionArrow4 = false;
                    }
                }
                else if (instructionSequence == 7)
                {
                    imovePossible = true;
                    GoOnVisible = true;
                    GoBackVisible = true;
                    text = "Now set a starting point and \nan incrementation value\nthat are appropriate for this \nloop.  Try not to hit any empty\nspaces! Press 'FIRE!' when you \nare ready to execute the \nloop!";
                    instructionArrow2 = false;
                    instructionArrow3 = true;
                    instructionArrow4 = false;
                    if (loopXmax <= maxXbunny)
                    {
                        instructionSequence = 6;
                    }

                }
                if (instructionSequence == 8)
                {
                    text = "Cure all of the bunnies \nto move on to the \nnext mission!\n\nNote: You can open or close \nthis instruction panel\nby clicking the yellow \n'Instructions' button below.";
                    GoOnVisible = false;
                    GoBackVisible = true;
                    instructionArrow = false;
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    instructionArrow4 = false;
                    if (loopXmax <= maxXbunny)
                    {
                        instructionSequence = 6;
                    }

                }
                if (loopRun > 0)
                {
                    instructionSequence = 10;
                    imovePossible = true;
                    GoOnVisible = false;
                    GoBackVisible = false;
                    text = "Great job!  Try using loop fire\n again on this loop!\n\n           You have \n           " + (3 - loopRun) + " out of 3 \n        enemy sets left!";
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    instructionArrow4 = false;
                }

                if (bunnyError == true || ammoError == true || resetRun == true)
                {
                    errors();
                }


            }
        }
            private void level3instr()
        {
            if (level == 3)
            {
                levelTime.Start();
                time2.Start();
                if (time2.Elapsed.Seconds < 1)
                {
                    //bunnyError = false;
                    click = true;
                    instructionSequence = 1;
                    previousSequence = 1;
                    activityTime.Start();

                }
                if (time2.Elapsed.Seconds > 1)
                {
                    time2.Stop();
                }
                text2 = " ";
                text3 = " ";
                if (instructionSequence == 1)
                {
                    instructionArrow4 = false;
                    imovePossible = true;
                    GoBackVisible = false;
                    goOn = goOn1;
                    GoOnVisible = true;
                    goOnFlash = false;
                    text = "You're really getting the hang \nof this! Now we are going to \nbegin using 2-D arrays!\n2-D arrays are like many 1-D \narrays piled on top of each \nother, and they have both\nr (rows) and c (columns).";
                }
                if (instructionSequence == 2)
                {
                    imovePossible = true;
                    GoBackVisible = true;
                    GoOnVisible = true;
                    goOnFlash = false;
                    goOn = goOn1;
                    instructionArrow4 = false;
                    text = "   Just like before, use the\narray declaration to increase \nthe size of the array, and then \nmanually fill elements of the \narray where you want to \nstrike! The format for a 2-D \narray is: \n     'int fire_on [r][c]'\n";
                    text2 = "\n\n\n\n\n\n\n\n     Once again, you are \n  firing one shot at a time! ";
                }
                if (instructionSequence == 3)
                {
                    imovePossible = true;
                    GoBackVisible = true;
                    instructionArrow4 = false;
                    GoOnVisible = false;
                    text = "Cure all of the bunnies \nto move on to the \nnext mission!\n     You have " + enemyDisplay + " target(s)\n           remaining!\n\n";
                    text3 = "\n\n\n\n\n\nNote: You can open or close \nthis instruction panel by \nclicking the yellow 'Instructions' \nbutton below.";
                }
                if (instructionSequence == 99)
                {
                    imovePossible = false;
                    GoBackVisible = false;
                    GoOnVisible = false;
                    instructionArrow4 = false;
                    text = "Your array is too small! \nIncrease the size in \norder to fire!";
                }
                if (bunnyError == true || ammoError == true || resetRun == true)
                {
                    errors();
                }
            }
        }
            private void level4instr()
        {
            if (level == 4)
            {
                levelTime.Start();
                text2 = " ";
                text3 = " ";
                time2.Start();
                if (time2.Elapsed.Seconds < 1)
                {
                    click = true;
                    instructionSequence = 1;
                    previousSequence = 1;
                    activityTime.Start();
                }
                if (time2.Elapsed.Seconds > 1)
                {
                    time2.Stop();
                }



                if (instructionSequence == 1)
                {
                    instructionArrow4 = false;
                    GoOnVisible = true;
                    GoBackVisible = false;
                    text = "Fantastic work, soldier!\n\nThese bunnies are becoming\norganized!  They are arranging\nthemselves in columns and \nrows! Now we need to use \n'nested loops' to defeat them!";
                    imovePossible = true;
                    goOnFlash = true;

                }
                if (instructionSequence == 2)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    text = "Just like when you made a \nloop for a 1-D array, you will \nnow have to loop both the \n'c' (columns) and 'r' (rows) \nof the array.  As before, \nchoose a starting point, \nmaximum, and incrementation \nvalue; but this time for the 'r.'";
                    imovePossible = true;
                    goOnFlash = true;
                    instructionArrow4 = false;

                }
                if (instructionSequence == 3)
                {
                    GoOnVisible = true;
                    GoBackVisible = true;
                    text = "After you have set the 'r,' \ndo the same for the 'c' value.  \nEvery time the loop for 'r' is \nexecuted, the inner 'nested' \nloop for 'c' will run.  Think \nabout the problem carefully \nbefore you fire, as ammunition \nis extremely limited.  \nAlso notice you only have \n1 loop fire available.";
                    imovePossible = true;
                    goOnFlash = false;
                    goOn = goOn1;
                    instructionArrow4 = false;
                }
                if (instructionSequence == 4)
                {
                    text = "Cure all of the bunnies \nto move on to the \nnext mission!";
                    text3 = "\n\n\n\nNote: You can open or close \nthis instruction panel\nby clicking the yellow \n'Instructions' button below.";
                    GoOnVisible = false;
                    GoBackVisible = true;
                    instructionArrow4 = false;
                    imovePossible = true;
                }
                if (loopRun > 0)
                {
                    instructionSequence = 10;
                    imovePossible = true;
                    GoOnVisible = false;
                    GoBackVisible = false;
                    text = "Great job!  Try using loop fire\n again on this loop!\n\n           You have \n           " + (3 - loopRun) + " out of 3 \n        enemy sets left!";
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    goOnFlash = false;
                    goOn = goOn1;
                    instructionArrow4 = false;
                }
                if (bunnyError == true || ammoError == true || resetRun == true)
                {
                    errors();
                }

            }
        }
            private void level5instr()
        {
            if (level == 5)
            {
                levelTime.Start();
                text2 = " ";
                text3 = " ";
                if (instructionSequence != 1)
                {
                    text2 = " ";
                }
                time2.Start();
                if (time2.Elapsed.Seconds < 1)
                {
                    click = true;
                    instructionSequence = 1;
                    previousSequence = 1;
                    activityTime.Start();

                }
                if (time2.Elapsed.Seconds > 1)
                {
                    time2.Stop();
                }
                if (instructionSequence == 1)
                {
                    imovePossible = false;
                    click = true;
                    GoOnVisible = true;
                    goOnFlash = true;
                    GoBackVisible = false;
                    instructionArrow = false;
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    instructionArrow4 = false;
                    instructionArrow5 = false;
                    text = "   Look! These bunnies have \nbecome even more evil and \norganized!  They are now \norganized into complex \nformations that can only be hit \n\n \nAmmunition is still limited, \nso don't hit any empty spaces \nor bunnies that have \nbeen cured!";
                    text2 = "\n\n\n\n\nby firing twice, using 2\n 'nested for loops'!";
                }

                else if (instructionSequence == 2)
                {
                    imovePossible = true;
                    GoBackVisible = true;
                    GoOnVisible = true;
                    goOn = goOn1;
                    goOnFlash = false;
                    instructionArrow4 = false;
                    text = "Some of these bunnies \nare exceptionally strong!\nA leader bunny, \nlike the one on the\n right, will need to be \nhit twice to fully cure.  \nKeep this in mind while \ndeciding where to place your \nloops!";
                    instructionArrow5 = true;
                }
                else if (instructionSequence == 3)
                {
                    imovePossible = true;
                    text = "Cure all of the bunnies \nto move on to the \nnext mission!\n\nNote: You can open or close \nthis instruction panel\nby clicking the yellow \n'Instructions' button below.";
                    GoOnVisible = false;
                    GoBackVisible = true;
                    instructionArrow4 = false;
                    instructionArrow5 = false;

                }

                if (loopRun > 0)
                {
                    instructionSequence = 10;
                    imovePossible = true;
                    GoOnVisible = false;
                    GoBackVisible = false;
                    text = "Great job!  Try using loop fire\n again on this loop!\n\n           You have \n           " + (3 - loopRun) + " out of 3 \n        enemy sets left!";
                    instructionArrow2 = false;
                    instructionArrow3 = false;
                    instructionArrow4 = false;
                    goOnFlash = false;
                    goOn = goOn1;
                }

                if (bunnyError == true || ammoError == true || resetRun == true)
                {
                    errors();
                }
            }
        }


        private void errors()
        {





            if (bunnyError == false)
            {
                tryAgainBunny = false;
            }
            if (bunnyError == true)
            {
                text = "Your array is too small! \nIncrease the size in \norder to fire!";
                text2 = " ";
                text3 = " ";
                GoBackVisible = false;
                GoOnVisible = false;
                instructionArrow = false;
                instructionArrow2 = false;
                instructionArrow3 = false;
                instructionArrow4 = true;
                tryAgainBunny = true;
            }


            if (bunnyError == false)
            {
                tryAgainBunny = false;
                //time3.Reset();
            }
            if (ammoError == true)
            {
                if (ammoAvailable == 0)
                {
                    text = "    \nBe more careful with your \nshots and keep an eye on \nyour shot ammunition\nin blue on your Information \nScreen!You often only have \nenough for 1 shot per enemy!\n Press 'Reload' to try again!";
                    text2 = "   You ran out of ammo!";
                }
                if (loopAmmo == 0)
                {
                    text = "    \nBe more careful with your \nshots, check you max values,\n and keep an eye on your\n loop and shot ammoin blue\n on your Information Screen!\nYou often only have \nenough for 1 shot per enemy!\n Press 'Reload' to try again!";
                    text2 = "   You ran out of loops! ";
                }
                
                text3 = " ";
                GoBackVisible = false;
                GoOnVisible = false;
                instructionArrow = false;
                instructionArrow2 = false;
                instructionArrow3 = false;
                instructionArrow4 = true;
                instructionArrow5 = false;
                tryAgain = true;
            }

            if (ammoError == false)
            {
                text2 = " ";
                tryAgain = false;
                instructionArrow4 = false;
               // time3.Reset();

            }

            if (resetRun == true)
            {

                text = "\n\n  Restart the level from the \n   beginning with new sets \n          of enemies\n\n\n              OR\n    Reload the cannon and \n     try again on this set.";
                text2 = "Press 'Reset' again to cancel";
                text3 = " ";
                GoBackVisible = false;
                GoOnVisible = false;
                instructionArrow = false;
                instructionArrow2 = false;
                instructionArrow3 = false;
                instructionArrow4 = false;
                instructionArrow5 = false;

            }
            if (resetRun == false && tryAgain == false)
            {
                text2 = " ";
                instructionArrow4 = false;
                // time3.Reset();

            }
        }

        private void lineMovement(GameTime gameTime)
        {
            
            float moveFactorPerSecond = 150 *
        (float)gameTime.ElapsedRealTime.Milliseconds / 1000.0f;
            float lineUpChange = lineSpeed * moveFactorPerSecond;

            lineUpPosX = 150 + moveLineX;
            lineUpPosY = (449);
            lineSidePosX = (128);
            lineSidePosY = 460 + moveLineY;
            int Xmax = 257;
            int Xmin = 135;
            int Ymin = 455;
            int Ymax = 540;


            if ((lineUpPosX < Xmax) && right == 1)
            {
                moveLineX += lineSpeed;
                if (lineUpPosX == Xmax - 1)
                { right = 0; }
            }

            if ((right == 0) && lineUpPosX > Xmin)
            {
                moveLineX -= lineSpeed;

                if (lineUpPosX == Xmin + 1)
                { right = 1; }

            }

            if ((up == 0) && lineSidePosY < Ymax)
            {
                moveLineY += lineSpeed;

                if (lineSidePosY == Ymax - 1)
                { up = 1; }

            }
            if ((lineSidePosY > Ymin) && up == 1)
            {
                moveLineY -= lineSpeed;

                if (lineSidePosY == Ymin + 1)
                { up = 0; }
            }


            Rectangle crossBar = new Rectangle(lineSidePosX, lineSidePosY, 131, 5);
            sprites.Draw(lineSide, crossBar, Color.White);
            Rectangle cross2Bar = new Rectangle(lineUpPosX, lineUpPosY, 5, 105);
            sprites.Draw(lineUp, cross2Bar, Color.White);

            //sprites.DrawString(_font, Convert.ToString(mouseX),
            //        new Vector2(Xmin, Ymax - 10), textColor);
            //sprites.DrawString(_font, Convert.ToString(mouseY),
            //        new Vector2(Xmax - 25, Ymax - 10), textColor);
            sprites.DrawString(_font, " Information:",
        new Vector2(Xmin - 5, Ymin - 25), Color.Red);
            sprites.DrawString(_font, "Enemies: " + enemyDisplay,
                    new Vector2(Xmin, Ymin), Color.Blue);
            sprites.DrawString(_font, "Ammo: " + ammoAvailable,
        new Vector2(Xmin, Ymin + 20), Color.Blue);
        if (loopFire == true)
            {
                sprites.DrawString(_font, "Loops: " + loopAmmo,
                    new Vector2(Xmin, Ymin + 40), Color.Blue);
                sprites.DrawString(_font, "Sets: " + (3 - loopRun)+"/3",
                new Vector2(Xmin, Ymin + 60), Color.Blue);
                
            }
        }

        private void drawGrid()
        {
            
            for (int x = 0; x < array_maxX; x++)
            {
                for (int y = 0; y < array_maxY; y++)
                {
                    
                    gridPos= new Vector2(
                        (((resolutionWidth - (74 * array_maxX)) / 2) + 74 * x), ((y * 74) + 40));
                    Vector2 gridPos_TextX = new Vector2(
                        (((resolutionWidth - (74 * array_maxX)) / 2) + (74 * x) + 35), ((y * 74) + 15));
                    sprites.Draw(grid2, gridPos, Color.White);
                    Vector2 gridPos_TextY = new Vector2(
                        (((resolutionWidth - (74 * array_maxX)) / 2) + (74 * x) - 15), ((y * 74) + (40) + 35));
                    sprites.Draw(grid2, gridPos, Color.White);
                    hitDefault.X = gridPos.X + 37 -15 - ((array_maxX - 1) * 75);
                    hitDefault.Y = 77-15;
                    
                    if (y == 0)
                    {
                        sprites.DrawString(_font, Convert.ToString(x),
                    gridPos_TextX, xColor);
                    }
                    if (x == 0)
                    {
                        sprites.DrawString(_font, Convert.ToString(y),
                    gridPos_TextY, yColor);
                    }
                
                    int enemies = 99;
                    int indexX;
                    int indexY;
                    for (indexX = 0; indexX < enemies; indexX++)
                {
                    enemyXcoord[indexX] = (((resolutionWidth - (74 * array_sizeX)) / 2) + (74 * indexX)) + 14;
                }

                //for (int t = 0; t < array_maxX; t++)
                //{
                //    for (int q = 0; q < array_maxY; q++)
                //    {

                        missBox[x,y] = new BoundingBox(
                            //new Vector3(gridPos.X + 25, gridPos.Y + 25, 0),
                            //new Vector3(gridPos.X + 45, gridPos.Y + 45, 0)
                            new Vector3((((resolutionWidth - (74 * array_maxX)) / 2) + 74 * x), ((y * 74) + 40), 0),
                            new Vector3(gridPos.X + 45, gridPos.Y + 45, 0)
                        );
                        missRect[x,y] = new Rectangle(Convert.ToInt16(gridPos.X + 25), Convert.ToInt16(gridPos.Y + 25), 28, 30);

                        //if (missed[q + t] == true)
                        //{
                        //    sprites.Draw(mouseimg1, missRect[q + t], Color.White);
                        //}

                //    }
                //}
                        if (fireSector.Intersects(missBox[x,y]) && fireOrdered == true)
                        {
                            sprites.Draw(missImg, missRect[x,y], Color.Blue);
                            missed[x,y] = true;
                        }
                        if (missed[x,y] == true)
                        {
                            sprites.Draw(missImg, missRect[x,y], Color.White);
                        }


                for (indexY = 0; indexY < enemies; indexY++)
                {
                    enemyYcoord[indexY] = (indexY * 74) + 54;
                }
                }
            }
        }
          
        //  RunLevelSettings has CONSTANT level declarations
        private void runLevelSettings()
        {

            if (level == 0)
            {

                Rectangle startRect = new Rectangle(0, 0, resolutionWidth, resolutionHeight);
                sprites.Draw(startup, startRect, Color.White);

                BoundingBox startBox = new BoundingBox(
                    new Vector3((491), (257), (0)),
                    new Vector3((694), (324), (0))
                );

                BoundingBox exitBox = new BoundingBox(
                    new Vector3((491), (387), (0)),
                    new Vector3((694), (444), (0))
                );

                mouseimg = mouseimg2;

                if (mouseBox.Intersects(startBox) && current_mouse.LeftButton == ButtonState.Pressed)
                {
                        Sound.Play("QUICKCL");
                        
                        level = 1;
                        ammoAvailable = 10;
                        loopAmmo = 10;
                }

                if (mouseBox.Intersects(exitBox) && current_mouse.LeftButton == ButtonState.Pressed)
                {
                    this.Exit();
                }
            }

            else if (level == 1)
            {
                activity = "Write code to fill the following elements of this array with '1'";
                numEnemies = 5;
                array_maxY = 1;


                for (int i = 0; i < numEnemies; i++)
                {
                    bunnyY[i] = 0;

                }
                if (loopRun == 0)
                {
                    stage0enemies = numEnemies;
                }
                loopFire = false;



                if (enemyDisplay == 0)
                {
                    
                    time5.Start();
                    if (time5.Elapsed.Seconds < 2)
                    {
                        ammoError = false;
                        if (time5.Elapsed.Seconds > 0)
                        {
                            if (cueHandleLoop == false)
                            {
                                Sound.PlayTechno();
                                cueHandleLoop = true;
                            }
                        }
                    }
                    if (time5.Elapsed.Seconds >= 2)
                    {
                        nextLevelScreen();
                        cueHandleLoop = false;
                        time5.Stop();
                    }
                }

                

  
            }
            else if (level == 2)
            {
                //Sound.Update();
                instructionArrow = false;
                array_maxY = 1;
                array_maxX = 10;
                loopFire = true;
                if (loopRun == 0)
                   {
                      stage0Start = xStart;
                      stage0increase = xIncrease;
                   }
                if (enemyDisplay == 0)
                {
                    time5.Start();
                    if (time5.Elapsed.Seconds < 2)
                    {
                        if (time5.Elapsed.Seconds > 0)
                        {
                            if (cueHandleLoop == false)
                            {
                                Sound.PlayTechno();   //Added
                                cueHandleLoop = true;

                            }
                        }
                        ammoError = false;
                    }

                    if (time5.Elapsed.Seconds >= 2)
                    {

                        loopRun++;
                        loopReset();
                        bunnyDeclare();
                        if (loopRun == 1)
                        {
                            stage1Start = xStart;
                            stage1increase = xIncrease;
                        }
                        if (loopRun == 2)
                        {
                            stage2Start = xStart;
                            stage2increase = xIncrease;
                        }

                        activityTime.Stop();
                        activityTime.Reset();
                        activityTime.Start();
                        time5.Stop();
                        time5.Reset();
                        cueHandleLoop = false; //Added
                        initialWrite = false;
                        
                    }
                }
                if (((stage0Start == stage1Start) && (stage0increase == stage1increase)) || ((stage0Start == stage2Start) && (stage0increase == stage2increase)) || ((stage2Start == stage1Start) && (stage2increase == stage1increase)))
                {

                    if (loopRun == 1)
                    {
                        loopReset();
                        bunnyDeclare();
                        stage1Start = xStart;
                        stage1increase = xIncrease;
                    }
                    if (loopRun == 2)
                    {
                        loopReset();
                        bunnyDeclare();
                        stage2Start = xStart;
                        stage2increase = xIncrease;
                    }

                } 

                if (loopRun == 0)
                {
                    stage0enemies = numEnemies;
                }
                if (loopRun == 1)
                {
                    stage1enemies = numEnemies;
                }
                if (loopRun == 2)
                {
                    stage2enemies = numEnemies;
                }

                if (loopRun == 3)
                {
                    nextLevelScreen();
                }

                logXstart = xStart;
                logXincrease = xIncrease;
                activity = "Look at the pattern above to make the following loop: 'for (int x ="+logXstart+"; x <= 10; x+="+logXincrease+";)' or its equivalent";

            }

            else if (level == 3)
            {
                activity = "Write code to fill the following elements of this array with '1'";
                //Sound.Update();
                loopFire = false;
                if (enemyDisplay == 0)
                {
                    time5.Start();
                    if (time5.Elapsed.Seconds < 2)
                    {
                        if (time5.Elapsed.Seconds > 0)
                        {
                            if (cueHandleLoop == false)
                            {
                                Sound.PlayTechno();   //Added
                                cueHandleLoop = true;
                            }
                        }
                        ammoError = false;
                    }
                    if (time5.Elapsed.Seconds >= 2)
                    {
                        nextLevelScreen();
                        cueHandleLoop = false;
                    }
                }
                if (loopRun == 0)
                {
                    stage0enemies = numEnemies;
                }
            }

            else if (level == 4)
            {
                //technoMusic =
                //Sound.Update();
                loopFire = true;

                
                if (enemyDisplay == 0)
                {
                    time5.Start();
                    if (time5.Elapsed.Seconds < 2)
                    {
                        if (time5.Elapsed.Seconds > 0)
                        {
                            if (cueHandleLoop == false)
                            {
                                Sound.PlayTechno();   //Added
                                cueHandleLoop = true;
                            }
                        }
                        ammoError = false;
                    }
                    if (time5.Elapsed.Seconds >= 2)
                    {
                        
                        click = true;
                        loopReset();
                        bunnyDeclare();
                        loopRun++;
                        time5.Stop();
                        time5.Reset();
                        cueHandleLoop = false;
                        activityTime.Stop();
                        activityTime.Reset();
                        activityTime.Start();
                        initialWrite = false;

                    }

                }

                if (loopRun == 0)
                {
                    stage0enemies = numEnemies;
                    xColor = Color.Navy;
                    yColor = Color.MediumVioletRed;
                }
                if (loopRun == 1)
                {
                    stage1enemies = numEnemies;
                    xColor = Color.Gray;
                    yColor = Color.Gray;
                }
                if (loopRun == 2)
                {
                    xColor = bgColor;
                    yColor = bgColor;
                    stage2enemies = numEnemies;
                }

                if (loopRun == 3)
                {
                    nextLevelScreen();
                }
                activity = "Look at the pattern above to make the following loop and nested loop: \n'for (int y =" + yStart + "; y <= 5; y+=" + yIncrease + ";)\nfor (int x =" + xStart + "; x <= 10; x+=" + xIncrease + ";)' or its equivalent";
            }
            else if (level == 5)
            {
                //Sound.Update();
                loopFire = true;

                if (enemyDisplay == 0)
                {
                    time5.Start();
                    if (time5.Elapsed.Seconds < 2)
                    {
                        if (time5.Elapsed.Seconds > 0)
                        {
                            if (cueHandleLoop == false)
                            {
                                Sound.PlayTechno();   //Added
                                cueHandleLoop = true;
                            }
                        }
                        ammoError = false;
                    }
                    if (time5.Elapsed.Seconds >= 2)
                    {

                        loopReset();
                        bunnyDeclare();
                        loopRun++;
                        time5.Stop();
                        cueHandleLoop = false;
                        time5.Reset();
                        activityTime.Stop();
                        activityTime.Reset();
                        activityTime.Start();
                        initialWrite = false;
                        shots = 0;

                    }

                }
                if (loopRun == 0)
                {
                    stage0enemies = numEnemies;
                    xColor = Color.Navy;
                    yColor = Color.MediumVioletRed;
                }
                if (loopRun == 1)
                {
                    stage1enemies = numEnemies;
                    xColor = Color.Gray;
                    yColor = Color.Gray;
                }
                if (loopRun == 2)
                {
                    xColor = bgColor;
                    yColor = bgColor;
                    stage2enemies = numEnemies;
                }
                
                for (int i = 0; i < numEnemies; i++)
                {
                    for (int z = 0; z < i; z++)
                    {
                        if ((bunnyY[i] == bunnyY[z]) && (bunnyX[i] == bunnyX[z]))
                        {
                            if (loopRun == 0)
                            {
                                stage0enemies--;
                            }
                            if (loopRun == 1)
                            {
                                stage1enemies--;
                            }
                            if (loopRun == 2)
                            {
                                stage2enemies--;
                            }
                        }
                    }
                }

                if (loopRun == 3)
                {
                    endGame();

                }
                activity = "Look at the pattern above to make the following loops and nested loops: \n1: 'for (int y =" + logYstart + "; y <= 5; y+=" + logYincrease + ";)\nfor (int x =" + logXstart + "; x <= 10; x+=" + logXincrease + ";)'  2: 'for (int y =" + logYstart2 + "; y <= 5; y+=" + logYincrease2 + ";)\nfor (int x =" + logXstart2 + "; x <= 10; x+=" + logXincrease2 + ";)'";
               
            }


       }

        private void endGame()
        {
            //nextLevelScreen();
            if (happyPlay == false)
            {
                Sound.BGstop();
                Sound.PlayHappy();
                happyPlay = true;

            }
            enemiesCured = (stage0enemies + stage1enemies + stage2enemies);
            points = ((stage0enemies + stage1enemies + stage2enemies) * 50) - (500 * numResets);
            fireOrdered = false;
            Rectangle startRect = new Rectangle(0, 0, resolutionWidth, resolutionHeight);
            sprites.Draw(gameOverScreen, startRect, Color.White);

            BoundingBox backBox = new BoundingBox(
                new Vector3((595), (399), (0)),
                new Vector3((756), (458), (0))
            );

            BoundingBox exitBox = new BoundingBox(
            new Vector3((575), (501), (0)),
            new Vector3((765), (570), (0))
            );
            mouseimg = mouseimg2;


            sprites.DrawString(end_font, "Enemies Cured This Level: " + Convert.ToString(enemiesCured), new Vector2(25, 250), Color.Black);
            sprites.DrawString(end_font, "Ammunition Resupplies: " + Convert.ToString(numResets), new Vector2(25, 280), Color.Black);
            sprites.DrawString(end_font, "Points Earned: \n    Enemies Cured: " + Convert.ToString(enemiesCured) + " * 50 = " + ((stage0enemies + stage1enemies + stage2enemies) * 50) + "\n   --Resupplies: " + numResets + " * 500 = " + (numResets * 500) + "\n    = " + points, new Vector2(25, 310), Color.Black);
            sprites.DrawString(end_font, "Bunnies Who Were Happier Being Evil: " + Convert.ToString(randomCured), new Vector2(25, 410), Color.Black);
            sprites.DrawString(end_font, "Total Points: " + (points + totalPoints), new Vector2(25, 500), Color.Black);
            sprites.DrawString(end_font, "Total Enemies Cured: " + (enemiesCured + totalEenemies), new Vector2(25, 540), Color.Black);


            if (mouseBox.Intersects(backBox) && current_mouse.LeftButton == ButtonState.Pressed)
            {
                Sound.Play("QUICKCL");
                fireOrdered = false;
                movePossible = true;
                targetPosX = 0;
                targetPosY = 0;
                array_maxX = 1;
                array_maxY = 1;
                instructionArrow = false;
                for (int i = 0; i < bunnyHit.Length; i++)
                    bunnyHit[i] = 0;
                loopRun = 0;
                stage0enemies = 0;
                stage1enemies = 0;
                stage2enemies = 0;
                numResets = 0;
                totalPoints += points;
                totalEenemies += enemiesCured;
                loopReset();
                bunnyDeclare();
                cueHandleLoop = false;
                Sound.Happystop();
                if (soundButton == soundOn)
                {
                    Sound.BG();
                }
                happyPlay = false;

                initialWrite = false;
                sets = 3;
                shots = 0;
            }
            if (mouseBox.Intersects(exitBox) && current_mouse.LeftButton == ButtonState.Pressed)
            {
                tw.WriteLine("Time to complete level (including Score screen): " + levelTime.Elapsed);
                tw.WriteLine("Time to complete Game (including Score screen): " + overallTime.Elapsed);
                tw.Close();
                this.Exit();
            }
        }
        
        private void loopReset()
        {
            for (int x = 0; x < array_maxX; x++)
            {
                for (int y = 0; y < array_maxY; y++)
                {
                    missed[x, y] = false;
                }
            }
            fireOrdered = false;
            movePossible = true;
            targetPosX = 0;
            targetPosY = 0;
            //array_maxX = 1;
            //array_maxY = 1;
            newLine10 = false;
            loopXmax = 1;
            loopYmax = 1;
            if (level == 2)
            {
                loopXmax = 1;
            }

            loopIndex = 0;
            loopIndexY = 0;
            displayNum = loopIndex;
            displayNumY = loopIndexY;
            increaseNum = 1;
            increaseNumY = 1;
            time.Stop();
            time.Reset();
            for (int i = 0; i < bunnyHit.Length; i++)
            {
                bunnyHit[i] = 0;
            }
            enemies = 0;
            enemies2 = 0;
            numEnemies = 0;
            bunny = 0;
            bunnyError = false;
            ammoError = false;
            instructionSequence = 1;
            //numResets = 0;
            maxXbunny = 0;
            minXbunny = 10;
            resetRun = false;

            //stage0Start = 9;
            //stage0increase = 9;
            //stage1Start = 8;
            //stage1increase = 8;
            //stage2Start = 7;
            //stage2increase = 7;




        }
        
        private void nextLevelScreen()
        {  

            enemiesCured = (stage0enemies + stage1enemies + stage2enemies);
            points = ((stage0enemies + stage1enemies + stage2enemies) * 50) - (500 * numResets);
            fireOrdered = false;
            Rectangle startRect = new Rectangle(0, 0, resolutionWidth, resolutionHeight);
            sprites.Draw(LevelComplete, startRect, Color.White);

            BoundingBox continueBox = new BoundingBox(
                new Vector3((491), (257), (0)),
                new Vector3((694), (324), (0))
            );

            BoundingBox backBox = new BoundingBox(
                new Vector3((491), (387), (0)),
                new Vector3((694), (444), (0))
            );
            mouseimg = mouseimg2;
            
            
            sprites.DrawString(end_font, "Enemies Cured This Level: "+Convert.ToString(enemiesCured), new Vector2(25, 250), Color.Black);
            sprites.DrawString(end_font, "Ammunition Resupplies: " + Convert.ToString(numResets), new Vector2(25, 280), Color.Black);
            sprites.DrawString(end_font, "Points Earned: \n    Enemies Cured: " + Convert.ToString(enemiesCured) + " * 50 = " + ((stage0enemies + stage1enemies + stage2enemies) * 50) + "\n   --Resupplies: "+numResets+" * 500 = " + (numResets * 500) + "\n    = " + points, new Vector2(25, 310), Color.Black);
            sprites.DrawString(end_font, "Bunnies Who Were Happier Being Evil: " + Convert.ToString(randomCured), new Vector2(25, 410), Color.Black);
            sprites.DrawString(end_font, "Total Points: " + (points + totalPoints), new Vector2(25, 500), Color.Black);
            sprites.DrawString(end_font, "Total Enemies Cured: " + (enemiesCured + totalEenemies), new Vector2(25, 540), Color.Black);

            
            if (mouseBox.Intersects(continueBox) && current_mouse.LeftButton == ButtonState.Pressed)
            {
                newLine24 = true;
            }
            else if (current_mouse.LeftButton == ButtonState.Released)
            {
                if (newLine24 == true)
                {
                    tw.WriteLine("Time to complete level (including Score screen): " + levelTime.Elapsed);
                    levelTime.Stop();
                    levelTime.Reset();

                    activityTime.Stop();
                    activityTime.Reset();
                    resetRun = false;
                    reset();
                    loopReset();
                    stage0enemies = 0;
                    stage1enemies = 0;
                    stage2enemies = 0;
                    numResets = 0;
                    fireOrdered = false;
                    loopRun = 0;
                    level++;
                    numEnemies = 0;
                    bunny = 0;
                    enemies = 0;
                    array_maxX = 1;
                    array_maxY = 1;
                    maxXbunny = 0;
                    bunnyDeclare();
                    Sound.Play("QUICKCL");
                    
                    movePossible = true;
                    targetPosX = 0;
                    targetPosY = 0;
                    time2.Reset();
                    numResets = 0;
                    totalPoints += points;
                    totalEenemies += enemiesCured;
                    for (int i = 0; i < bunnyHit.Length; i++)
                    {
                        bunnyHit[i] = 0;
                    }
                    time5.Reset();
                    cueHandleLoop = false;
                    enemyCount = 0;
                    initialWrite = false;
                    sets = 3;
                    shots = 0;

                  

                }
                newLine24 = false;
            }

            if (mouseBox.Intersects(backBox) && current_mouse.LeftButton == ButtonState.Pressed)
            {
                resetRun = false;
                reset();
                loopReset();
                Sound.Play("QUICKCL");
                fireOrdered = false;
                movePossible = true;
                targetPosX = 0;
                targetPosY = 0;
                array_maxX = 1;
                array_maxY = 1;
                instructionArrow = false;
                for (int i = 0; i < bunnyHit.Length; i++)
                    bunnyHit[i] = 0;
                loopRun = 0;
                stage0enemies = 0;
                stage1enemies = 0;
                stage2enemies = 0;
                numResets = 0;
                totalPoints += points;
                totalEenemies += enemiesCured;

                bunnyDeclare();
                time5.Reset();
                cueHandleLoop = false;
                tw.WriteLine("*******************USER RE-PLAYED LEVEL*****************");
                initialWrite = false;
                sets = 3;
                shots = 0;
            }
        }
    }
}
