using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using MercuryParticleEngine;
using MercuryParticleEngine.Emitters;
using MercuryParticleEngine.Modifiers;
using System.Diagnostics;

namespace WindowsGame1
{
    class Bunny
    {
        public int bunnyX;
        public int bunnyY;
        public BoundingBox bunnyBox;
        public int bunnyHit;
        public Texture2D bunnyType;
        ContentManager content;
        public String type;

        public Bunny(int x, int y, string type, int[] enemyXcoord, int[] enemyYcoord, ContentManager C)
        {
            this.type = type;
            bunnyX = x;
            bunnyY = y;
            bunnyHit= 0;
            content = C;
            bunnyBox = new BoundingBox(
                new Vector3((enemyXcoord[x]), (enemyYcoord[y]), (0)),
                new Vector3((enemyXcoord[x] + 25), (enemyYcoord[y] + 25), (0))
                );

            switch (type)
            {
                case "bad": bunnyType = content.Load<Texture2D>("bunny1"); break;
                case "good": bunnyType = content.Load<Texture2D>("bunny0"); break;
                case "strong": bunnyType = content.Load<Texture2D>("bunny2"); break;
            }

        }
        public void Draw(SpriteBatch sprites, int[] enemyXcoord, int[] enemyYcoord)
        {
            if (bunnyHit == 0)
            {
                bunnyType = content.Load<Texture2D>("bunny1");
            }
            if (bunnyHit == 1)
            {
                bunnyType = content.Load<Texture2D>("bunny0");
            }
            if (bunnyHit == 2)
            {
                bunnyType = content.Load<Texture2D>("bunny2");
            }

            sprites.Draw(bunnyType, new Rectangle(enemyXcoord[bunnyX], enemyYcoord[bunnyY], 50, 50), Color.White);
        }
    }
}
